import { ScaleBand, ScaleLinear } from 'd3-scale';
import * as React from 'react';
import './BarChart.css';
interface DataPoint {
    tooltip?: React.ReactNode;
    x: number;
    y: number;
}
interface Props<T> {
    barsWidth: number;
    data: Array<DataPoint & T>;
    height: number;
    onBarClick?: (point: DataPoint & T) => void;
    padding?: [number, number, number, number];
    width: number;
    xTicks?: string[];
    xValues?: string[];
}
export default class BarChart<T> extends React.PureComponent<Props<T>> {
    handleClick: (point: DataPoint & T) => void;
    renderXTicks: (xScale: ScaleBand<number>, yScale: ScaleLinear<number, number>) => JSX.Element | null;
    renderXValues: (xScale: ScaleBand<number>, yScale: ScaleLinear<number, number>) => JSX.Element | null;
    renderBars: (xScale: ScaleBand<number>, yScale: ScaleLinear<number, number>) => JSX.Element;
    render(): JSX.Element;
}
export {};
