"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
require("./ColorGradientLegend.css");
var NA_SPACING = 4;
function ColorGradientLegend(_a) {
    var className = _a.className, colorScale = _a.colorScale, colorNA = _a.colorNA, _b = _a.padding, padding = _b === void 0 ? [12, 24, 0, 0] : _b, height = _a.height, width = _a.width;
    var colorRange = colorScale.range();
    var colorDomain = colorScale.domain();
    var lastColorIdx = colorRange.length - 1;
    var lastDomainIdx = colorDomain.length - 1;
    var widthNoPadding = width - padding[1];
    var rectHeight = height - padding[0];
    return (React.createElement("svg", { className: className, height: height, width: width },
        React.createElement("defs", null,
            React.createElement("linearGradient", { id: "gradient-legend" }, colorRange.map(function (color, idx) { return (React.createElement("stop", { key: idx, offset: idx / lastColorIdx, stopColor: String(color) })); }))),
        React.createElement("g", { transform: "translate(" + padding[3] + ", " + padding[0] + ")" },
            React.createElement("rect", { fill: "url(#gradient-legend)", height: rectHeight, width: widthNoPadding, x: 0, y: 0 }),
            colorDomain.map(function (d, idx) { return (React.createElement("text", { className: "gradient-legend-text", dy: "-2px", key: idx, x: widthNoPadding * (idx / lastDomainIdx), y: 0 }, d)); })),
        colorNA && (React.createElement("g", { transform: "translate(" + widthNoPadding + ", " + padding[0] + ")" },
            React.createElement("rect", { fill: colorNA, height: rectHeight, width: padding[1] - NA_SPACING, x: NA_SPACING, y: 0 }),
            React.createElement("text", { className: "gradient-legend-na", dy: "-2px", x: NA_SPACING + (padding[1] - NA_SPACING) / 2, y: 0 }, "N/A")))));
}
exports.default = ColorGradientLegend;
//# sourceMappingURL=ColorGradientLegend.js.map