import { ScaleBand, ScaleLinear } from 'd3-scale';
import * as React from 'react';
import './BarChart.css';
import './Histogram.css';
interface Props {
    alignTicks?: boolean;
    bars: number[];
    height: number;
    padding?: [number, number, number, number];
    yTicks?: string[];
    yTooltips?: string[];
    yValues?: string[];
    width: number;
}
declare type XScale = ScaleLinear<number, number>;
declare type YScale = ScaleBand<number>;
export default class Histogram extends React.PureComponent<Props> {
    renderBar(d: number, index: number, xScale: XScale, yScale: YScale): JSX.Element;
    renderValue(d: number, index: number, xScale: XScale, yScale: YScale): JSX.Element | null;
    renderTick(index: number, xScale: XScale, yScale: YScale): JSX.Element | null;
    renderBars(xScale: XScale, yScale: YScale): JSX.Element;
    render(): JSX.Element;
}
export {};
