import { ScaleLinear } from 'd3-scale';
import * as React from 'react';
import './LineChart.css';
interface DataPoint {
    x: number;
    y?: number;
}
interface Props {
    backdropConstraints?: [number, number];
    data: DataPoint[];
    displayBackdrop?: boolean;
    displayPoints?: boolean;
    displayVerticalGrid?: boolean;
    domain?: [number, number];
    height: number;
    padding?: [number, number, number, number];
    width?: number;
    xTicks?: {}[];
    xValues?: {}[];
}
export default class LineChart extends React.PureComponent<Props> {
    renderBackdrop(xScale: ScaleLinear<number, number>, yScale: ScaleLinear<number, number>): JSX.Element | null;
    renderPoints(xScale: ScaleLinear<number, number>, yScale: ScaleLinear<number, number>): JSX.Element | null;
    renderVerticalGrid(xScale: ScaleLinear<number, number>, yScale: ScaleLinear<number, number>): JSX.Element | null;
    renderXTicks(xScale: ScaleLinear<number, number>, yScale: ScaleLinear<number, number>): JSX.Element | null;
    renderXValues(xScale: ScaleLinear<number, number>, yScale: ScaleLinear<number, number>): JSX.Element | null;
    renderLine(xScale: ScaleLinear<number, number>, yScale: ScaleLinear<number, number>): JSX.Element;
    renderChart: (width: number) => JSX.Element;
    render(): JSX.Element;
}
export {};
