"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var d3_hierarchy_1 = require("d3-hierarchy");
var React = require("react");
require("./TreeMap.css");
var TreeMapRect_1 = require("./TreeMapRect");
var TreeMap = (function (_super) {
    __extends(TreeMap, _super);
    function TreeMap() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mostCommitPrefix = function (labels) {
            var sortedLabels = labels.slice(0).sort();
            var firstLabel = sortedLabels[0];
            var firstLabelLength = firstLabel.length;
            var lastLabel = sortedLabels[sortedLabels.length - 1];
            var i = 0;
            while (i < firstLabelLength && firstLabel.charAt(i) === lastLabel.charAt(i)) {
                i++;
            }
            var prefix = firstLabel.substr(0, i);
            var prefixTokens = prefix.split(/[\s\\/]/);
            var lastPrefixPart = prefixTokens[prefixTokens.length - 1];
            return prefix.substr(0, prefix.length - lastPrefixPart.length);
        };
        return _this;
    }
    TreeMap.prototype.render = function () {
        var _this = this;
        var _a = this.props, items = _a.items, height = _a.height, width = _a.width;
        var hierarchy = d3_hierarchy_1.hierarchy({ children: items })
            .sum(function (d) { return d.size; })
            .sort(function (a, b) { return (b.value || 0) - (a.value || 0); });
        var treemap = d3_hierarchy_1.treemap().round(true).size([width, height]);
        var nodes = treemap(hierarchy).leaves();
        var prefix = this.mostCommitPrefix(items.map(function (item) { return item.label; }));
        var halfWidth = width / 2;
        return (React.createElement("div", { className: "sonar-d3" },
            React.createElement("div", { className: "treemap-container", style: { width: width, height: height } }, nodes.map(function (node) { return (React.createElement(TreeMapRect_1.default, { fill: node.data.color, height: node.y1 - node.y0, icon: node.data.icon, itemKey: node.data.key, key: node.data.key, label: node.data.label, link: node.data.link, onClick: _this.props.onRectangleClick, placement: node.x0 === 0 || node.x1 < halfWidth ? 'right' : 'left', prefix: prefix, tooltip: node.data.tooltip, width: node.x1 - node.x0, x: node.x0, y: node.y0 })); }))));
    };
    return TreeMap;
}(React.PureComponent));
exports.default = TreeMap;
//# sourceMappingURL=TreeMap.js.map