"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var d3_scale_1 = require("d3-scale");
var React = require("react");
var react_router_1 = require("react-router");
var Tooltip_1 = require("../controls/Tooltip");
var LinkIcon_1 = require("../icons/LinkIcon");
var SIZE_SCALE = d3_scale_1.scaleLinear().domain([3, 15]).range([11, 18]).clamp(true);
var TreeMapRect = (function (_super) {
    __extends(TreeMapRect, _super);
    function TreeMapRect() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleLinkClick = function (event) {
            event.stopPropagation();
        };
        _this.handleRectClick = function () {
            if (_this.props.onClick) {
                _this.props.onClick(_this.props.itemKey);
            }
        };
        _this.renderLink = function () {
            var _a = _this.props, link = _a.link, height = _a.height, width = _a.width;
            var hasMinSize = width >= 24 && height >= 24 && (width >= 48 || height >= 50);
            if (!hasMinSize || link == null) {
                return null;
            }
            return (React.createElement(react_router_1.Link, { className: "treemap-link", onClick: _this.handleLinkClick, to: link },
                React.createElement(LinkIcon_1.default, null)));
        };
        _this.renderCell = function () {
            var cellStyles = {
                left: _this.props.x,
                top: _this.props.y,
                width: _this.props.width,
                height: _this.props.height,
                backgroundColor: _this.props.fill,
                fontSize: SIZE_SCALE(_this.props.width / _this.props.label.length),
                lineHeight: _this.props.height + "px",
                cursor: _this.props.onClick != null ? 'pointer' : 'default',
            };
            var isTextVisible = _this.props.width >= 40 && _this.props.height >= 45;
            var isIconVisible = _this.props.width >= 24 && _this.props.height >= 26;
            return (React.createElement("div", { className: "treemap-cell", onClick: _this.handleRectClick, role: "treeitem", style: cellStyles, tabIndex: 0 },
                React.createElement("div", { className: "treemap-inner", style: { maxWidth: _this.props.width } },
                    isIconVisible && (React.createElement("span", { className: classNames('treemap-icon', { 'spacer-right': isTextVisible }) }, _this.props.icon)),
                    isTextVisible &&
                        (_this.props.prefix ? (React.createElement("span", { className: "treemap-text" },
                            _this.props.prefix,
                            React.createElement("br", null),
                            _this.props.label.substr(_this.props.prefix.length))) : (React.createElement("span", { className: "treemap-text" }, _this.props.label)))),
                _this.renderLink()));
        };
        return _this;
    }
    TreeMapRect.prototype.render = function () {
        var _a = this.props, placement = _a.placement, tooltip = _a.tooltip;
        return (React.createElement(Tooltip_1.default, { overlay: tooltip || undefined, placement: placement || 'left' }, this.renderCell()));
    };
    return TreeMapRect;
}(React.PureComponent));
exports.default = TreeMapRect;
//# sourceMappingURL=TreeMapRect.js.map