"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var react_router_1 = require("react-router");
var l10n_1 = require("../../helpers/l10n");
var DropdownIcon_1 = require("../icons/DropdownIcon");
var SettingsIcon_1 = require("../icons/SettingsIcon");
var buttons_1 = require("./buttons");
var clipboard_1 = require("./clipboard");
var Dropdown_1 = require("./Dropdown");
var Tooltip_1 = require("./Tooltip");
function ActionsDropdown(props) {
    var children = props.children, className = props.className, overlayPlacement = props.overlayPlacement, small = props.small, toggleClassName = props.toggleClassName;
    return (React.createElement(Dropdown_1.default, { className: className, onOpen: props.onOpen, overlay: React.createElement("ul", { className: "menu" }, children), overlayPlacement: overlayPlacement },
        React.createElement(buttons_1.Button, { className: classNames('dropdown-toggle', toggleClassName, {
                'button-small': small,
            }) },
            React.createElement(SettingsIcon_1.default, { size: small ? 12 : 14 }),
            React.createElement(DropdownIcon_1.default, { className: "little-spacer-left" }))));
}
exports.default = ActionsDropdown;
var ActionsDropdownItem = (function (_super) {
    __extends(ActionsDropdownItem, _super);
    function ActionsDropdownItem() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function (event) {
            event.preventDefault();
            event.currentTarget.blur();
            if (_this.props.onClick) {
                _this.props.onClick();
            }
        };
        return _this;
    }
    ActionsDropdownItem.prototype.render = function () {
        var _this = this;
        var className = classNames(this.props.className, { 'text-danger': this.props.destructive });
        if (this.props.download && typeof this.props.to === 'string') {
            return (React.createElement("li", null,
                React.createElement("a", { className: className, download: this.props.download, href: this.props.to, id: this.props.id }, this.props.children)));
        }
        if (this.props.to) {
            return (React.createElement("li", null,
                React.createElement(react_router_1.Link, { className: className, id: this.props.id, to: this.props.to }, this.props.children)));
        }
        if (this.props.copyValue) {
            return (React.createElement(clipboard_1.ClipboardBase, null, function (_a) {
                var setCopyButton = _a.setCopyButton, copySuccess = _a.copySuccess;
                return (React.createElement(Tooltip_1.default, { overlay: l10n_1.translate('copied_action'), visible: copySuccess },
                    React.createElement("li", { "data-clipboard-text": _this.props.copyValue, ref: setCopyButton },
                        React.createElement("a", { className: className, href: "#", id: _this.props.id, onClick: _this.handleClick }, _this.props.children))));
            }));
        }
        return (React.createElement("li", null,
            React.createElement("a", { className: className, href: "#", id: this.props.id, onClick: this.handleClick }, this.props.children)));
    };
    return ActionsDropdownItem;
}(React.PureComponent));
exports.ActionsDropdownItem = ActionsDropdownItem;
function ActionsDropdownDivider() {
    return React.createElement("li", { className: "divider" });
}
exports.ActionsDropdownDivider = ActionsDropdownDivider;
//# sourceMappingURL=ActionsDropdown.js.map