"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var theme_1 = require("../theme");
var TabContainer = theme_1.styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  display: flex;\n  flex-direction: row;\n"], ["\n  display: flex;\n  flex-direction: row;\n"])));
var baseBorder = function (_a) {
    var theme = _a.theme;
    return "1px solid " + theme.colors.barBorderColor;
};
var highlightHoverMixin = function (_a) {
    var theme = _a.theme;
    return "\n  &:hover {\n    background-color: " + theme.colors.barBackgroundColorHighlight + ";\n  }\n";
};
var StyledTab = theme_1.styled.button(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  position: relative;\n  background-color: ", ";\n  border-top: ", ";\n  border-left: ", ";\n  border-right: none;\n  border-bottom: none;\n  margin-bottom: -1px;\n  min-width: 128px;\n  min-height: 56px;\n  ", "\n  outline: 0;\n  padding: calc(2 * ", ");\n\n  ", "\n\n  &:last-child {\n    border-right: ", ";\n  }\n"], ["\n  position: relative;\n  background-color: ", ";\n  border-top: ", ";\n  border-left: ", ";\n  border-right: none;\n  border-bottom: none;\n  margin-bottom: -1px;\n  min-width: 128px;\n  min-height: 56px;\n  ", "\n  outline: 0;\n  padding: calc(2 * ", ");\n\n  ", "\n\n  &:last-child {\n    border-right: ", ";\n  }\n"])), function (props) { return (props.active ? 'white' : props.theme.colors.barBackgroundColor); }, baseBorder, baseBorder, function (props) { return !props.active && 'cursor: pointer;'; }, theme_1.themeSize('gridSize'), function (props) { return (!props.active ? highlightHoverMixin : null); }, baseBorder);
var ActiveBorder = theme_1.styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  display: ", ";\n  background-color: ", ";\n  height: 3px;\n  width: 100%;\n  position: absolute;\n  left: 0;\n  top: -1px;\n"], ["\n  display: ", ";\n  background-color: ", ";\n  height: 3px;\n  width: 100%;\n  position: absolute;\n  left: 0;\n  top: -1px;\n"])), function (props) { return (props.active ? 'block' : 'none'); }, theme_1.themeColor('blue'));
function BoxedTabs(props) {
    var className = props.className, tabs = props.tabs, selected = props.selected;
    return (React.createElement(TabContainer, { className: className }, tabs.map(function (_a, i) {
        var key = _a.key, label = _a.label;
        return (React.createElement(StyledTab, { active: selected === key, key: i, onClick: function () { return selected !== key && props.onSelect(key); }, type: "button" },
            React.createElement(ActiveBorder, { active: selected === key }),
            label));
    })));
}
exports.default = BoxedTabs;
var templateObject_1, templateObject_2, templateObject_3;
//# sourceMappingURL=BoxedTabs.js.map