"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var DeferredSpinner_1 = require("../ui/DeferredSpinner");
require("./Checkbox.css");
var Checkbox = (function (_super) {
    __extends(Checkbox, _super);
    function Checkbox() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function (event) {
            event.preventDefault();
            event.currentTarget.blur();
            if (!_this.props.disabled) {
                _this.props.onCheck(!_this.props.checked, _this.props.id);
            }
        };
        return _this;
    }
    Checkbox.prototype.render = function () {
        var _a = this.props, checked = _a.checked, children = _a.children, disabled = _a.disabled, id = _a.id, loading = _a.loading, right = _a.right, thirdState = _a.thirdState, title = _a.title;
        var className = classNames('icon-checkbox', {
            'icon-checkbox-checked': checked,
            'icon-checkbox-single': thirdState,
            'icon-checkbox-disabled': disabled,
        });
        if (children) {
            return (React.createElement("a", { "aria-checked": checked, className: classNames('link-checkbox', this.props.className, {
                    note: disabled,
                    disabled: disabled,
                }), href: "#", id: id, onClick: this.handleClick, role: "checkbox", title: title },
                right && children,
                React.createElement(DeferredSpinner_1.default, { loading: Boolean(loading) },
                    React.createElement("i", { className: className })),
                !right && children));
        }
        if (loading) {
            return React.createElement(DeferredSpinner_1.default, null);
        }
        return (React.createElement("a", { "aria-checked": checked, className: classNames(className, this.props.className), href: "#", id: id, onClick: this.handleClick, role: "checkbox", title: title }));
    };
    Checkbox.defaultProps = {
        thirdState: false,
    };
    return Checkbox;
}(React.PureComponent));
exports.default = Checkbox;
//# sourceMappingURL=Checkbox.js.map