import * as React from 'react';
import { ModalProps } from './Modal';
import { ChildrenProps } from './SimpleModal';
export interface ConfirmModalProps<T> extends ModalProps {
    cancelButtonText?: string;
    confirmButtonText: string;
    confirmData?: T;
    confirmDisable?: boolean;
    isDestructive?: boolean;
    onConfirm: (data?: T) => void | Promise<void | Response>;
}
interface Props<T> extends ConfirmModalProps<T> {
    header: string;
    headerDescription?: React.ReactNode;
    onClose: () => void;
}
export default class ConfirmModal<T = string> extends React.PureComponent<Props<T>> {
    mounted: boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    handleSubmit: () => Promise<void> | undefined;
    renderModalContent: ({ onCloseClick, onFormSubmit, submitting }: ChildrenProps) => JSX.Element;
    render(): JSX.Element;
}
export {};
