"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var DeferredSpinner_1 = require("../ui/DeferredSpinner");
var buttons_1 = require("./buttons");
var ClickEventBoundary_1 = require("./ClickEventBoundary");
var SimpleModal_1 = require("./SimpleModal");
var ConfirmModal = (function (_super) {
    __extends(ConfirmModal, _super);
    function ConfirmModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mounted = false;
        _this.handleSubmit = function () {
            var result = _this.props.onConfirm(_this.props.confirmData);
            if (result) {
                return result.then(_this.props.onClose, function () { });
            }
            else {
                _this.props.onClose();
                return undefined;
            }
        };
        _this.renderModalContent = function (_a) {
            var onCloseClick = _a.onCloseClick, onFormSubmit = _a.onFormSubmit, submitting = _a.submitting;
            var _b = _this.props, children = _b.children, confirmButtonText = _b.confirmButtonText, confirmDisable = _b.confirmDisable, header = _b.header, headerDescription = _b.headerDescription, isDestructive = _b.isDestructive, _c = _b.cancelButtonText, cancelButtonText = _c === void 0 ? l10n_1.translate('cancel') : _c;
            return (React.createElement(ClickEventBoundary_1.default, null,
                React.createElement("form", { onSubmit: onFormSubmit },
                    React.createElement("header", { className: "modal-head" },
                        React.createElement("h2", null, header),
                        headerDescription),
                    React.createElement("div", { className: "modal-body" }, children),
                    React.createElement("footer", { className: "modal-foot" },
                        React.createElement(DeferredSpinner_1.default, { className: "spacer-right", loading: submitting }),
                        React.createElement(buttons_1.SubmitButton, { autoFocus: true, className: isDestructive ? 'button-red' : undefined, disabled: submitting || confirmDisable }, confirmButtonText),
                        React.createElement(buttons_1.ResetButtonLink, { disabled: submitting, onClick: onCloseClick }, cancelButtonText)))));
        };
        return _this;
    }
    ConfirmModal.prototype.componentDidMount = function () {
        this.mounted = true;
    };
    ConfirmModal.prototype.componentWillUnmount = function () {
        this.mounted = false;
    };
    ConfirmModal.prototype.render = function () {
        var _a = this.props, header = _a.header, onClose = _a.onClose, noBackdrop = _a.noBackdrop, size = _a.size;
        var modalProps = { header: header, onClose: onClose, noBackdrop: noBackdrop, size: size };
        return (React.createElement(SimpleModal_1.default, __assign({ onSubmit: this.handleSubmit }, modalProps), this.renderModalContent));
    };
    return ConfirmModal;
}(React.PureComponent));
exports.default = ConfirmModal;
//# sourceMappingURL=ConfirmModal.js.map