import * as React from 'react';
import { PopupPlacement } from '../ui/popups';
import './Dropdown.css';
interface OnClickCallback {
    (event?: React.SyntheticEvent<HTMLElement>): void;
}
interface RenderProps {
    closeDropdown: () => void;
    onToggleClick: OnClickCallback;
    open: boolean;
}
interface Props {
    children: ((renderProps: RenderProps) => JSX.Element) | React.ReactElement<{
        onClick: OnClickCallback;
    }>;
    className?: string;
    closeOnClick?: boolean;
    closeOnClickOutside?: boolean;
    onOpen?: () => void;
    overlay: React.ReactNode;
    overlayPlacement?: PopupPlacement;
    noOverlayPadding?: boolean;
    tagName?: string;
}
interface State {
    open: boolean;
}
export default class Dropdown extends React.PureComponent<Props, State> {
    state: State;
    componentDidUpdate(_: Props, prevState: State): void;
    closeDropdown: () => void;
    handleToggleClick: (event?: React.SyntheticEvent<HTMLElement, Event> | undefined) => void;
    render(): React.ReactElement<{
        className: string;
    }, string | ((props: any) => React.ReactElement<any, string | any | (new (props: any) => React.Component<any, any, any>)> | null) | (new (props: any) => React.Component<any, any, any>)>;
}
interface OverlayProps {
    className?: string;
    children: React.ReactNode;
    noPadding?: boolean;
    placement?: PopupPlacement;
}
export declare class DropdownOverlay extends React.Component<OverlayProps> {
    get placement(): PopupPlacement.Bottom | PopupPlacement;
    renderPopup: (leftFix?: number | undefined, topFix?: number | undefined) => JSX.Element;
    render(): JSX.Element;
}
export {};
