"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var popups_1 = require("../ui/popups");
require("./Dropdown.css");
var ScreenPositionFixer_1 = require("./ScreenPositionFixer");
var Toggler_1 = require("./Toggler");
var Dropdown = (function (_super) {
    __extends(Dropdown, _super);
    function Dropdown() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { open: false };
        _this.closeDropdown = function () { return _this.setState({ open: false }); };
        _this.handleToggleClick = function (event) {
            if (event) {
                event.preventDefault();
                event.currentTarget.blur();
            }
            _this.setState(function (state) { return ({ open: !state.open }); });
        };
        return _this;
    }
    Dropdown.prototype.componentDidUpdate = function (_, prevState) {
        if (!prevState.open && this.state.open && this.props.onOpen) {
            this.props.onOpen();
        }
    };
    Dropdown.prototype.render = function () {
        var a11yAttrs = {
            'aria-expanded': String(this.state.open),
            'aria-haspopup': 'true',
        };
        var child = React.isValidElement(this.props.children)
            ? React.cloneElement(this.props.children, __assign({ onClick: this.handleToggleClick }, a11yAttrs))
            : this.props.children({
                closeDropdown: this.closeDropdown,
                onToggleClick: this.handleToggleClick,
                open: this.state.open,
            });
        var _a = this.props, _b = _a.closeOnClick, closeOnClick = _b === void 0 ? true : _b, _c = _a.closeOnClickOutside, closeOnClickOutside = _c === void 0 ? false : _c;
        var toggler = (React.createElement(Toggler_1.default, { closeOnClick: closeOnClick, closeOnClickOutside: closeOnClickOutside, onRequestClose: this.closeDropdown, open: this.state.open, overlay: React.createElement(DropdownOverlay, { noPadding: this.props.noOverlayPadding, placement: this.props.overlayPlacement }, this.props.overlay) }, child));
        return React.createElement(this.props.tagName || 'div', { className: classNames('dropdown', this.props.className) }, toggler);
    };
    return Dropdown;
}(React.PureComponent));
exports.default = Dropdown;
var DropdownOverlay = (function (_super) {
    __extends(DropdownOverlay, _super);
    function DropdownOverlay() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.renderPopup = function (leftFix, topFix) { return (React.createElement(popups_1.Popup, { arrowStyle: leftFix !== undefined && topFix !== undefined
                ? { transform: "translate(" + -leftFix + "px, " + -topFix + "px)" }
                : undefined, className: _this.props.className, noPadding: _this.props.noPadding, placement: _this.placement, style: leftFix !== undefined && topFix !== undefined
                ? { marginLeft: "calc(50% + " + leftFix + "px)" }
                : undefined }, _this.props.children)); };
        return _this;
    }
    Object.defineProperty(DropdownOverlay.prototype, "placement", {
        get: function () {
            return this.props.placement || popups_1.PopupPlacement.Bottom;
        },
        enumerable: true,
        configurable: true
    });
    DropdownOverlay.prototype.render = function () {
        var _this = this;
        if (this.placement === popups_1.PopupPlacement.Bottom) {
            return (React.createElement(ScreenPositionFixer_1.default, null, function (_a) {
                var leftFix = _a.leftFix, topFix = _a.topFix;
                return _this.renderPopup(leftFix, topFix);
            }));
        }
        else {
            return this.renderPopup();
        }
    };
    return DropdownOverlay;
}(React.Component));
exports.DropdownOverlay = DropdownOverlay;
//# sourceMappingURL=Dropdown.js.map