"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var FavoriteIcon_1 = require("../icons/FavoriteIcon");
var buttons_1 = require("./buttons");
var Tooltip_1 = require("./Tooltip");
var FavoriteButton = (function (_super) {
    __extends(FavoriteButton, _super);
    function FavoriteButton() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    FavoriteButton.prototype.render = function () {
        var _a = this.props, className = _a.className, favorite = _a.favorite, qualifier = _a.qualifier, toggleFavorite = _a.toggleFavorite;
        var tooltip = favorite
            ? l10n_1.translate('favorite.current', qualifier)
            : l10n_1.translate('favorite.check', qualifier);
        var ariaLabel = l10n_1.translate('favorite.action', favorite ? 'remove' : 'add');
        return (React.createElement(Tooltip_1.default, { overlay: tooltip },
            React.createElement(buttons_1.ButtonLink, { "aria-label": ariaLabel, className: classNames('favorite-link', 'link-no-underline', className), onClick: toggleFavorite },
                React.createElement(FavoriteIcon_1.default, { favorite: favorite }))));
    };
    return FavoriteButton;
}(React.PureComponent));
exports.default = FavoriteButton;
//# sourceMappingURL=FavoriteButton.js.map