"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@emotion/core");
var React = require("react");
var path_1 = require("../../helpers/path");
var theme_1 = require("../theme");
var buttons_1 = require("./buttons");
function GlobalMessages(_a) {
    var closeGlobalMessage = _a.closeGlobalMessage, messages = _a.messages;
    if (messages.length === 0) {
        return null;
    }
    return (React.createElement(MessagesContainer, null, messages.map(function (message) { return (React.createElement(GlobalMessage, { closeGlobalMessage: closeGlobalMessage, key: message.id, message: message })); })));
}
exports.default = GlobalMessages;
var MessagesContainer = theme_1.styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  position: fixed;\n  z-index: ", ";\n  top: 0;\n  left: 50%;\n  width: 350px;\n  margin-left: -175px;\n"], ["\n  position: fixed;\n  z-index: ", ";\n  top: 0;\n  left: 50%;\n  width: 350px;\n  margin-left: -175px;\n"])), theme_1.themeGet('zIndexes', 'processContainerZIndex'));
var GlobalMessage = (function (_super) {
    __extends(GlobalMessage, _super);
    function GlobalMessage() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClose = function () {
            _this.props.closeGlobalMessage(_this.props.message.id);
        };
        return _this;
    }
    GlobalMessage.prototype.render = function () {
        var message = this.props.message;
        return (React.createElement(Message, { "data-test": "global-message__" + message.level, level: message.level },
            path_1.cutLongWords(message.message),
            React.createElement(CloseButton, { className: "button-small", color: "#fff", level: message.level, onClick: this.handleClose })));
    };
    return GlobalMessage;
}(React.PureComponent));
exports.GlobalMessage = GlobalMessage;
var appearAnim = core_1.keyframes(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n"], ["\n  from {\n    opacity: 0;\n  }\n  to {\n    opacity: 1;\n  }\n"])));
var Message = theme_1.styled.div(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  position: relative;\n  padding: 0 30px 0 10px;\n  line-height: ", ";\n  border-radius: 0 0 3px 3px;\n  box-sizing: border-box;\n  color: #ffffff;\n  background-color: ", ";\n  text-align: center;\n  opacity: 0;\n  animation: ", " 0.2s ease forwards;\n\n  & + & {\n    margin-top: calc(", " / 2);\n    border-radius: 3px;\n  }\n"], ["\n  position: relative;\n  padding: 0 30px 0 10px;\n  line-height: ", ";\n  border-radius: 0 0 3px 3px;\n  box-sizing: border-box;\n  color: #ffffff;\n  background-color: ",
    ";\n  text-align: center;\n  opacity: 0;\n  animation: ", " 0.2s ease forwards;\n\n  & + & {\n    margin-top: calc(", " / 2);\n    border-radius: 3px;\n  }\n"])), theme_1.themeSize('controlHeight'), function (_a) {
    var level = _a.level, theme = _a.theme;
    return level === 'SUCCESS' ? theme.colors.green : theme.colors.red;
}, appearAnim, theme_1.themeSize('gridSize'));
var CloseButton = theme_1.styled(buttons_1.ClearButton)(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  position: absolute;\n  top: calc(", " / 4);\n  right: calc(", " / 4);\n\n  &:hover svg,\n  &:focus svg {\n    color: ", ";\n  }\n"], ["\n  position: absolute;\n  top: calc(", " / 4);\n  right: calc(", " / 4);\n\n  &:hover svg,\n  &:focus svg {\n    color: ", ";\n  }\n"])), theme_1.themeSize('gridSize'), theme_1.themeSize('gridSize'), function (_a) {
    var level = _a.level, theme = _a.theme;
    return (level === 'SUCCESS' ? theme.colors.green : theme.colors.red);
});
var templateObject_1, templateObject_2, templateObject_3, templateObject_4;
//# sourceMappingURL=GlobalMessages.js.map