"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var HelpIcon_1 = require("../icons/HelpIcon");
var theme_1 = require("../theme");
require("./HelpTooltip.css");
var Tooltip_1 = require("./Tooltip");
function HelpTooltip(_a) {
    var _b = _a.size, size = _b === void 0 ? 12 : _b, props = __rest(_a, ["size"]);
    return (React.createElement("div", { className: classNames('help-tooltip', props.className) },
        React.createElement(Tooltip_1.default, { mouseLeaveDelay: 0.25, onShow: props.onShow, overlay: props.overlay, placement: props.placement },
            React.createElement("span", { className: "display-inline-flex-center" }, props.children || (React.createElement(theme_1.ThemeConsumer, null, function (theme) { return React.createElement(HelpIcon_1.default, { fill: theme.colors.gray71, size: size }); }))))));
}
exports.default = HelpTooltip;
function DarkHelpTooltip(_a) {
    var _b = _a.size, size = _b === void 0 ? 12 : _b, props = __rest(_a, ["size"]);
    return (React.createElement(HelpTooltip, __assign({}, props),
        React.createElement(theme_1.ThemeConsumer, null, function (_a) {
            var colors = _a.colors;
            return (React.createElement(HelpIcon_1.default, { fill: colors.transparentBlack, fillInner: colors.white, size: size }));
        })));
}
exports.DarkHelpTooltip = DarkHelpTooltip;
//# sourceMappingURL=HelpTooltip.js.map