"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var measures_1 = require("../../helpers/measures");
var DeferredSpinner_1 = require("../ui/DeferredSpinner");
var buttons_1 = require("./buttons");
function ListFooter(props) {
    var className = props.className, count = props.count, loading = props.loading, needReload = props.needReload, total = props.total, _a = props.ready, ready = _a === void 0 ? true : _a;
    var hasMore = total && total > count;
    var button;
    if (needReload && props.reload) {
        button = (React.createElement(buttons_1.Button, { className: "spacer-left", "data-test": "reload", disabled: loading, onClick: props.reload }, l10n_1.translate('reload')));
    }
    else if (hasMore && props.loadMore) {
        button = (React.createElement(buttons_1.Button, { className: "spacer-left", disabled: loading, "data-test": "show-more", onClick: props.loadMore }, l10n_1.translate('show_more')));
    }
    return (React.createElement("footer", { className: classNames('spacer-top note text-center', { 'new-loading': !ready }, className) },
        l10n_1.translateWithParameters('x_of_y_shown', measures_1.formatMeasure(count, 'INT', null), measures_1.formatMeasure(total, 'INT', null)),
        button,
        loading && React.createElement(DeferredSpinner_1.default, { className: "text-bottom spacer-left position-absolute" })));
}
exports.default = ListFooter;
//# sourceMappingURL=ListFooter.js.map