import * as React from 'react';
import './Modal.css';
export interface ModalProps {
    children: React.ReactNode;
    size?: 'small' | 'medium' | 'large';
    noBackdrop?: boolean;
}
interface Props extends ModalProps {
    className?: string;
    overlayClassName?: string;
    onAfterOpen?(): void;
    onAfterClose?(): void;
    onRequestClose?(event: React.MouseEvent | React.KeyboardEvent): void;
    shouldFocusAfterRender?: boolean;
    shouldCloseOnOverlayClick?: boolean;
    shouldCloseOnEsc?: boolean;
    contentLabel: string;
}
export default function Modal(props: Props): JSX.Element;
export {};
