import * as React from 'react';
export interface ChildrenProps {
    onClick: () => void;
    onFormSubmit: (event: React.FormEvent<HTMLFormElement>) => void;
}
export interface ModalProps {
    onClose: () => void;
}
export interface Props {
    children: (props: ChildrenProps) => React.ReactNode;
    modal: (props: ModalProps) => React.ReactNode;
}
interface State {
    modal: boolean;
}
export default class ModalButton extends React.PureComponent<Props, State> {
    mounted: boolean;
    state: State;
    componentDidMount(): void;
    componentWillUnmount(): void;
    handleButtonClick: () => void;
    handleFormSubmit: (event?: React.FormEvent<HTMLFormElement> | undefined) => void;
    handleCloseModal: () => void;
    render(): JSX.Element;
}
export {};
