"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var AlertErrorIcon_1 = require("../icons/AlertErrorIcon");
var AlertSuccessIcon_1 = require("../icons/AlertSuccessIcon");
function ModalValidationField(props) {
    var description = props.description, dirty = props.dirty, error = props.error;
    var isValid = dirty && props.touched && error === undefined;
    var showError = dirty && props.touched && error !== undefined;
    return (React.createElement("div", { className: "modal-validation-field" },
        props.label,
        props.children({ className: classNames({ 'is-invalid': showError, 'is-valid': isValid }) }),
        showError && React.createElement(AlertErrorIcon_1.default, { className: "little-spacer-top" }),
        isValid && React.createElement(AlertSuccessIcon_1.default, { className: "little-spacer-top" }),
        showError && React.createElement("p", { className: "text-danger" }, error),
        description && React.createElement("div", { className: "modal-field-description" }, description)));
}
exports.default = ModalValidationField;
//# sourceMappingURL=ModalValidationField.js.map