"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_dom_1 = require("react-dom");
var OutsideClickHandler = (function (_super) {
    __extends(OutsideClickHandler, _super);
    function OutsideClickHandler() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mounted = false;
        _this.addClickHandler = function () {
            window.addEventListener('click', _this.handleWindowClick);
        };
        _this.removeClickHandler = function () {
            window.removeEventListener('click', _this.handleWindowClick);
        };
        _this.handleWindowClick = function (event) {
            if (_this.mounted) {
                var node = react_dom_1.findDOMNode(_this);
                if (!node || !node.contains(event.target)) {
                    _this.props.onClickOutside();
                }
            }
        };
        return _this;
    }
    OutsideClickHandler.prototype.componentDidMount = function () {
        var _this = this;
        this.mounted = true;
        setTimeout(function () {
            _this.addClickHandler();
        }, 0);
    };
    OutsideClickHandler.prototype.componentWillUnmount = function () {
        this.mounted = false;
        this.removeClickHandler();
    };
    OutsideClickHandler.prototype.render = function () {
        return this.props.children;
    };
    return OutsideClickHandler;
}(React.Component));
exports.default = OutsideClickHandler;
//# sourceMappingURL=OutsideClickHandler.js.map