"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var react_intl_1 = require("react-intl");
var l10n_1 = require("../../helpers/l10n");
var RecommendedIcon_1 = require("../icons/RecommendedIcon");
require("./Radio.css");
require("./RadioCard.css");
function RadioCard(props) {
    var className = props.className, disabled = props.disabled, onClick = props.onClick, recommended = props.recommended, selected = props.selected, titleInfo = props.titleInfo, _a = props.vertical, vertical = _a === void 0 ? false : _a;
    var isActionable = Boolean(onClick);
    return (React.createElement("div", { "aria-checked": selected, className: classNames('radio-card', {
            'radio-card-actionable': isActionable,
            'radio-card-vertical': vertical,
            disabled: disabled,
            selected: selected,
        }, className), onClick: isActionable && !disabled ? onClick : undefined, role: "radio", tabIndex: 0 },
        React.createElement("h2", { className: "radio-card-header big-spacer-bottom" },
            React.createElement("span", { className: "display-flex-center link-radio" },
                isActionable && (React.createElement("i", { className: classNames('icon-radio', 'spacer-right', { 'is-checked': selected }) })),
                props.title),
            titleInfo),
        React.createElement("div", { className: "radio-card-body" }, props.children),
        recommended && (React.createElement("div", { className: "radio-card-recommended" },
            React.createElement(RecommendedIcon_1.default, { className: "spacer-right" }),
            React.createElement(react_intl_1.FormattedMessage, { defaultMessage: recommended, id: recommended, values: { recommended: React.createElement("strong", null, l10n_1.translate('recommended')) } })))));
}
exports.default = RadioCard;
//# sourceMappingURL=RadioCard.js.map