"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var React = require("react");
var react_dom_1 = require("react-dom");
var theme_1 = require("../theme");
var ScreenPositionFixer = (function (_super) {
    __extends(ScreenPositionFixer, _super);
    function ScreenPositionFixer(props) {
        var _this = _super.call(this, props) || this;
        _this.addEventListeners = function () {
            window.addEventListener('resize', _this.throttledPosition);
        };
        _this.removeEventListeners = function () {
            window.removeEventListener('resize', _this.throttledPosition);
        };
        _this.reset = function () {
            _this.setState({ leftFix: undefined, topFix: undefined });
        };
        _this.position = function () {
            var edgeMargin = 0.5 * _this.props.theme.rawSizes.grid;
            var node = react_dom_1.findDOMNode(_this);
            if (node && node instanceof Element) {
                var _a = node.getBoundingClientRect(), width = _a.width, height = _a.height, left = _a.left, top_1 = _a.top;
                var _b = document.documentElement, clientHeight = _b.clientHeight, clientWidth = _b.clientWidth;
                var leftFix = 0;
                if (left < edgeMargin) {
                    leftFix = edgeMargin - left;
                }
                else if (left + width > clientWidth - edgeMargin) {
                    leftFix = clientWidth - edgeMargin - left - width;
                }
                var topFix = 0;
                if (top_1 < edgeMargin) {
                    topFix = edgeMargin - top_1;
                }
                else if (top_1 + height > clientHeight - edgeMargin) {
                    topFix = clientHeight - edgeMargin - top_1 - height;
                }
                _this.setState({ leftFix: leftFix, topFix: topFix });
            }
        };
        _this.state = {};
        _this.throttledPosition = lodash_1.throttle(_this.position, 50);
        return _this;
    }
    ScreenPositionFixer.prototype.componentDidMount = function () {
        this.addEventListeners();
        this.position();
    };
    ScreenPositionFixer.prototype.componentDidUpdate = function (prevProps) {
        if (!prevProps.ready && this.props.ready) {
            this.position();
        }
        else if (prevProps.ready && !this.props.ready) {
            this.reset();
        }
    };
    ScreenPositionFixer.prototype.componentWillUnmount = function () {
        this.removeEventListeners();
    };
    ScreenPositionFixer.prototype.render = function () {
        return this.props.children(this.state);
    };
    return ScreenPositionFixer;
}(React.Component));
exports.ScreenPositionFixer = ScreenPositionFixer;
exports.default = theme_1.withTheme(ScreenPositionFixer);
//# sourceMappingURL=ScreenPositionFixer.js.map