import { Cancelable } from 'lodash';
import * as React from 'react';
import './SearchBox.css';
interface Props {
    autoFocus?: boolean;
    className?: string;
    id?: string;
    innerRef?: (node: HTMLInputElement | null) => void;
    loading?: boolean;
    maxLength?: number;
    minLength?: number;
    onChange: (value: string) => void;
    onClick?: React.MouseEventHandler<HTMLInputElement>;
    onFocus?: React.FocusEventHandler<HTMLInputElement>;
    onKeyDown?: React.KeyboardEventHandler<HTMLInputElement>;
    placeholder: string;
    value?: string;
}
interface State {
    value: string;
}
export default class SearchBox extends React.PureComponent<Props, State> {
    debouncedOnChange: ((query: string) => void) & Cancelable;
    input?: HTMLInputElement | null;
    constructor(props: Props);
    componentDidUpdate(prevProps: Props): void;
    changeValue: (value: string, debounced?: boolean) => void;
    handleInputChange: (event: React.SyntheticEvent<HTMLInputElement, Event>) => void;
    handleInputKeyDown: (event: React.KeyboardEvent<HTMLInputElement>) => void;
    handleResetClick: () => void;
    ref: (node: HTMLInputElement | null) => void;
    render(): JSX.Element;
}
export {};
