import * as React from 'react';
interface Props<T> {
    autofocus?: boolean;
    canCreate?: boolean;
    className?: string;
    clearable?: boolean;
    defaultOptions?: T[];
    minimumQueryLength?: number;
    multi?: boolean;
    onSearch: (query: string) => Promise<T[]>;
    onSelect?: (option: T) => void;
    onMultiSelect?: (options: T[]) => void;
    promptTextCreator?: (label: string) => string;
    renderOption?: (option: T) => JSX.Element;
    resetOnBlur?: boolean;
    value?: T | T[];
}
interface State<T> {
    loading: boolean;
    options: T[];
    query: string;
}
export default class SearchSelect<T extends {
    value: string;
}> extends React.PureComponent<Props<T>, State<T>> {
    mounted: boolean;
    constructor(props: Props<T>);
    componentDidMount(): void;
    componentWillUnmount(): void;
    get autofocus(): boolean;
    get minimumQueryLength(): number;
    get resetOnBlur(): boolean;
    handleSearch: (query: string) => void;
    handleChange: (option: T | T[]) => void;
    handleInputChange: (query: string) => void;
    handleFilterOption: () => boolean;
    render(): JSX.Element;
}
export {};
