"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var Select_1 = require("./Select");
var SearchSelect = (function (_super) {
    __extends(SearchSelect, _super);
    function SearchSelect(props) {
        var _this = _super.call(this, props) || this;
        _this.mounted = false;
        _this.handleSearch = function (query) {
            var currentQuery = query;
            _this.props.onSearch(currentQuery).then(function (options) {
                if (_this.mounted) {
                    _this.setState(function (state) { return ({
                        loading: false,
                        options: state.query === currentQuery ? options : state.options,
                    }); });
                }
            }, function () {
                if (_this.mounted) {
                    _this.setState({ loading: false });
                }
            });
        };
        _this.handleChange = function (option) {
            if (Array.isArray(option)) {
                if (_this.props.onMultiSelect) {
                    _this.props.onMultiSelect(option);
                }
            }
            else if (_this.props.onSelect) {
                _this.props.onSelect(option);
            }
        };
        _this.handleInputChange = function (query) {
            if (query.length >= _this.minimumQueryLength) {
                _this.setState({ loading: true, query: query });
                _this.handleSearch(query);
            }
            else {
                var options = (query.length === 0 && _this.props.defaultOptions) || [];
                _this.setState({ options: options, query: query });
            }
        };
        _this.handleFilterOption = function () { return true; };
        _this.state = { loading: false, options: props.defaultOptions || [], query: '' };
        _this.handleSearch = lodash_1.debounce(_this.handleSearch, 250);
        return _this;
    }
    SearchSelect.prototype.componentDidMount = function () {
        this.mounted = true;
    };
    SearchSelect.prototype.componentWillUnmount = function () {
        this.mounted = false;
    };
    Object.defineProperty(SearchSelect.prototype, "autofocus", {
        get: function () {
            return this.props.autofocus !== undefined ? this.props.autofocus : true;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SearchSelect.prototype, "minimumQueryLength", {
        get: function () {
            return this.props.minimumQueryLength !== undefined ? this.props.minimumQueryLength : 2;
        },
        enumerable: true,
        configurable: true
    });
    Object.defineProperty(SearchSelect.prototype, "resetOnBlur", {
        get: function () {
            return this.props.resetOnBlur !== undefined ? this.props.resetOnBlur : true;
        },
        enumerable: true,
        configurable: true
    });
    SearchSelect.prototype.render = function () {
        var Component = this.props.canCreate ? Select_1.Creatable : Select_1.default;
        return (React.createElement(Component, { autoFocus: this.autofocus, className: this.props.className, clearable: this.props.clearable, escapeClearsValue: false, filterOption: this.handleFilterOption, isLoading: this.state.loading, multi: this.props.multi, noResultsText: this.state.query.length < this.minimumQueryLength
                ? l10n_1.translateWithParameters('select2.tooShort', this.minimumQueryLength)
                : l10n_1.translate('select2.noMatches'), onBlurResetsInput: this.resetOnBlur, onChange: this.handleChange, onInputChange: this.handleInputChange, optionRenderer: this.props.renderOption, options: this.state.options, placeholder: l10n_1.translate('search_verb'), promptTextCreator: this.props.promptTextCreator, searchable: true, value: this.props.value, valueRenderer: this.props.renderOption }));
    };
    return SearchSelect;
}(React.PureComponent));
exports.default = SearchSelect;
//# sourceMappingURL=SearchSelect.js.map