"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var react_select_1 = require("react-select");
var lazyLoadComponent_1 = require("../lazyLoadComponent");
var buttons_1 = require("./buttons");
require("./Select.css");
var ReactSelectLib = Promise.resolve().then(function () { return require('react-select'); });
var ReactSelect = lazyLoadComponent_1.lazyLoadComponent(function () { return ReactSelectLib; });
var ReactCreatable = lazyLoadComponent_1.lazyLoadComponent(function () {
    return ReactSelectLib.then(function (lib) { return ({ default: lib.Creatable }); });
});
var ReactAsync = lazyLoadComponent_1.lazyLoadComponent(function () { return ReactSelectLib.then(function (lib) { return ({ default: lib.Async }); }); });
function renderInput() {
    return React.createElement(buttons_1.ClearButton, { className: "button-tiny spacer-left text-middle", iconProps: { size: 12 } });
}
function Select(_a) {
    var innerRef = _a.innerRef, props = __rest(_a, ["innerRef"]);
    var ReactSelectAny = ReactSelect;
    var clearable = props.clearable ? Boolean(props.value) : false;
    return (React.createElement(ReactSelectAny, __assign({}, props, { clearable: clearable, clearRenderer: renderInput, ref: innerRef })));
}
exports.default = Select;
exports.defaultFilterOptions = react_select_1.defaultFilterOptions;
function Creatable(props) {
    var ReactCreatableAny = ReactCreatable;
    return React.createElement(ReactCreatableAny, __assign({}, props, { clearRenderer: renderInput }));
}
exports.Creatable = Creatable;
function AsyncSelect(props) {
    return React.createElement(ReactAsync, __assign({}, props));
}
exports.AsyncSelect = AsyncSelect;
//# sourceMappingURL=Select.js.map