import * as React from 'react';
import './SelectList.css';
export declare enum SelectListFilter {
    All = "all",
    Selected = "selected",
    Unselected = "deselected"
}
interface Props {
    allowBulkSelection?: boolean;
    elements: string[];
    elementsTotalCount?: number;
    disabledElements?: string[];
    labelSelected?: string;
    labelUnselected?: string;
    labelAll?: string;
    needToReload?: boolean;
    onSearch: (searchParams: SelectListSearchParams) => Promise<void>;
    onSelect: (element: string) => Promise<void>;
    onUnselect: (element: string) => Promise<void>;
    pageSize?: number;
    readOnly?: boolean;
    renderElement: (element: string) => React.ReactNode;
    selectedElements: string[];
    withPaging?: boolean;
}
export interface SelectListSearchParams {
    filter: SelectListFilter;
    page?: number;
    pageSize?: number;
    query: string;
}
interface State {
    lastSearchParams: SelectListSearchParams;
    loading: boolean;
}
export default class SelectList extends React.PureComponent<Props, State> {
    mounted: boolean;
    constructor(props: Props);
    componentDidMount(): void;
    componentWillUnmount(): void;
    stopLoading: () => void;
    getFilter: () => SelectListFilter.All | SelectListFilter;
    search: (searchParams: Partial<SelectListSearchParams>) => void;
    changeFilter: (filter: SelectListFilter) => void;
    handleQueryChange: (query: string) => void;
    onLoadMore: () => void;
    onReload: () => void;
    render(): JSX.Element;
}
export {};
