"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var ListFooter_1 = require("./ListFooter");
var RadioToggle_1 = require("./RadioToggle");
var SearchBox_1 = require("./SearchBox");
require("./SelectList.css");
var SelectListListContainer_1 = require("./SelectListListContainer");
var SelectListFilter;
(function (SelectListFilter) {
    SelectListFilter["All"] = "all";
    SelectListFilter["Selected"] = "selected";
    SelectListFilter["Unselected"] = "deselected";
})(SelectListFilter = exports.SelectListFilter || (exports.SelectListFilter = {}));
var DEFAULT_PAGE_SIZE = 100;
var SelectList = (function (_super) {
    __extends(SelectList, _super);
    function SelectList(props) {
        var _this = _super.call(this, props) || this;
        _this.mounted = false;
        _this.stopLoading = function () {
            if (_this.mounted) {
                _this.setState({ loading: false });
            }
        };
        _this.getFilter = function () {
            return _this.state.lastSearchParams.query === ''
                ? _this.state.lastSearchParams.filter
                : SelectListFilter.All;
        };
        _this.search = function (searchParams) {
            return _this.setState(function (prevState) { return ({
                loading: true,
                lastSearchParams: __assign(__assign({}, prevState.lastSearchParams), searchParams),
            }); }, function () {
                return _this.props
                    .onSearch({
                    filter: _this.getFilter(),
                    page: _this.props.withPaging ? _this.state.lastSearchParams.page : undefined,
                    pageSize: _this.props.withPaging ? _this.state.lastSearchParams.pageSize : undefined,
                    query: _this.state.lastSearchParams.query,
                })
                    .then(_this.stopLoading)
                    .catch(_this.stopLoading);
            });
        };
        _this.changeFilter = function (filter) { return _this.search({ filter: filter, page: 1 }); };
        _this.handleQueryChange = function (query) { return _this.search({ page: 1, query: query }); };
        _this.onLoadMore = function () {
            return _this.search({
                page: _this.state.lastSearchParams.page != null ? _this.state.lastSearchParams.page + 1 : undefined,
            });
        };
        _this.onReload = function () { return _this.search({ page: 1 }); };
        _this.state = {
            lastSearchParams: {
                filter: SelectListFilter.Selected,
                page: 1,
                pageSize: props.pageSize ? props.pageSize : DEFAULT_PAGE_SIZE,
                query: '',
            },
            loading: false,
        };
        return _this;
    }
    SelectList.prototype.componentDidMount = function () {
        this.mounted = true;
        this.search({});
    };
    SelectList.prototype.componentWillUnmount = function () {
        this.mounted = false;
    };
    SelectList.prototype.render = function () {
        var _a = this.props, _b = _a.labelSelected, labelSelected = _b === void 0 ? l10n_1.translate('selected') : _b, _c = _a.labelUnselected, labelUnselected = _c === void 0 ? l10n_1.translate('unselected') : _c, _d = _a.labelAll, labelAll = _d === void 0 ? l10n_1.translate('all') : _d;
        var filter = this.state.lastSearchParams.filter;
        var disabled = this.state.lastSearchParams.query !== '';
        return (React.createElement("div", { className: "select-list" },
            React.createElement("div", { className: "display-flex-center" },
                React.createElement(RadioToggle_1.default, { className: "select-list-filter spacer-right", name: "filter", onCheck: this.changeFilter, options: [
                        { disabled: disabled, label: labelSelected, value: SelectListFilter.Selected },
                        { disabled: disabled, label: labelUnselected, value: SelectListFilter.Unselected },
                        { disabled: disabled, label: labelAll, value: SelectListFilter.All },
                    ], value: filter }),
                React.createElement(SearchBox_1.default, { autoFocus: true, loading: this.state.loading, onChange: this.handleQueryChange, placeholder: l10n_1.translate('search_verb'), value: this.state.lastSearchParams.query })),
            React.createElement(SelectListListContainer_1.default, { allowBulkSelection: this.props.allowBulkSelection, disabledElements: this.props.disabledElements || [], elements: this.props.elements, filter: this.getFilter(), onSelect: this.props.onSelect, onUnselect: this.props.onUnselect, readOnly: this.props.readOnly, renderElement: this.props.renderElement, selectedElements: this.props.selectedElements }),
            !!this.props.elementsTotalCount && (React.createElement(ListFooter_1.default, { count: this.props.elements.length, loadMore: this.onLoadMore, needReload: this.props.needToReload, reload: this.onReload, total: this.props.elementsTotalCount }))));
    };
    return SelectList;
}(React.PureComponent));
exports.default = SelectList;
//# sourceMappingURL=SelectList.js.map