import * as React from 'react';
import { SelectListFilter } from './SelectList';
interface Props {
    allowBulkSelection?: boolean;
    elements: string[];
    disabledElements: string[];
    filter: SelectListFilter;
    onSelect: (element: string) => Promise<void>;
    onUnselect: (element: string) => Promise<void>;
    readOnly?: boolean;
    renderElement: (element: string) => React.ReactNode;
    selectedElements: string[];
}
interface State {
    loading: boolean;
}
export default class SelectListListContainer extends React.PureComponent<Props, State> {
    mounted: boolean;
    state: State;
    componentDidMount(): void;
    componentWillUnmount(): void;
    stopLoading: () => void;
    isDisabled: (element: string) => boolean;
    isSelected: (element: string) => boolean;
    handleBulkChange: (checked: boolean) => void;
    renderBulkSelector(): JSX.Element;
    render(): JSX.Element;
}
export {};
