"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var DeferredSpinner_1 = require("../ui/DeferredSpinner");
var Checkbox_1 = require("./Checkbox");
var SelectList_1 = require("./SelectList");
var SelectListListElement_1 = require("./SelectListListElement");
var SelectListListContainer = (function (_super) {
    __extends(SelectListListContainer, _super);
    function SelectListListContainer() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mounted = false;
        _this.state = { loading: false };
        _this.stopLoading = function () {
            if (_this.mounted) {
                _this.setState({ loading: false });
            }
        };
        _this.isDisabled = function (element) {
            return _this.props.readOnly || _this.props.disabledElements.includes(element);
        };
        _this.isSelected = function (element) {
            return _this.props.selectedElements.includes(element);
        };
        _this.handleBulkChange = function (checked) {
            _this.setState({ loading: true });
            if (checked) {
                Promise.all(_this.props.elements.map(function (element) { return _this.props.onSelect(element); }))
                    .then(_this.stopLoading)
                    .catch(_this.stopLoading);
            }
            else {
                Promise.all(_this.props.selectedElements.map(function (element) { return _this.props.onUnselect(element); }))
                    .then(_this.stopLoading)
                    .catch(_this.stopLoading);
            }
        };
        return _this;
    }
    SelectListListContainer.prototype.componentDidMount = function () {
        this.mounted = true;
    };
    SelectListListContainer.prototype.componentWillUnmount = function () {
        this.mounted = false;
    };
    SelectListListContainer.prototype.renderBulkSelector = function () {
        var _a = this.props, elements = _a.elements, readOnly = _a.readOnly, selectedElements = _a.selectedElements;
        return (React.createElement(React.Fragment, null,
            React.createElement("li", null,
                React.createElement(Checkbox_1.default, { checked: selectedElements.length > 0, disabled: this.state.loading || readOnly, onCheck: this.handleBulkChange, thirdState: selectedElements.length > 0 && elements.length !== selectedElements.length },
                    React.createElement("span", { className: "big-spacer-left" },
                        l10n_1.translate('bulk_change'),
                        React.createElement(DeferredSpinner_1.default, { className: "spacer-left", loading: this.state.loading, timeout: 10 })))),
            React.createElement("li", { className: "divider" })));
    };
    SelectListListContainer.prototype.render = function () {
        var _this = this;
        var _a = this.props, allowBulkSelection = _a.allowBulkSelection, elements = _a.elements, filter = _a.filter;
        return (React.createElement("div", { className: classNames('select-list-list-container spacer-top') },
            React.createElement("ul", { className: "menu" },
                allowBulkSelection &&
                    elements.length > 0 &&
                    filter === SelectList_1.SelectListFilter.All &&
                    this.renderBulkSelector(),
                elements.map(function (element) { return (React.createElement(SelectListListElement_1.default, { disabled: _this.isDisabled(element), element: element, key: element, onSelect: _this.props.onSelect, onUnselect: _this.props.onUnselect, renderElement: _this.props.renderElement, selected: _this.isSelected(element) })); }))));
    };
    return SelectListListContainer;
}(React.PureComponent));
exports.default = SelectListListContainer;
//# sourceMappingURL=SelectListListContainer.js.map