"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var Checkbox_1 = require("./Checkbox");
var SelectListListElement = (function (_super) {
    __extends(SelectListListElement, _super);
    function SelectListListElement() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mounted = false;
        _this.state = { loading: false };
        _this.stopLoading = function () {
            if (_this.mounted) {
                _this.setState({ loading: false });
            }
        };
        _this.handleCheck = function (checked) {
            _this.setState({ loading: true });
            var request = checked ? _this.props.onSelect : _this.props.onUnselect;
            request(_this.props.element).then(_this.stopLoading, _this.stopLoading);
        };
        return _this;
    }
    SelectListListElement.prototype.componentDidMount = function () {
        this.mounted = true;
    };
    SelectListListElement.prototype.componentWillUnmount = function () {
        this.mounted = false;
    };
    SelectListListElement.prototype.render = function () {
        return (React.createElement("li", { className: classNames({ 'select-list-list-disabled': this.props.disabled }) },
            React.createElement(Checkbox_1.default, { checked: this.props.selected, className: classNames('select-list-list-checkbox', { active: this.props.active }), disabled: this.props.disabled, loading: this.state.loading, onCheck: this.handleCheck },
                React.createElement("span", { className: "little-spacer-left" }, this.props.renderElement(this.props.element)))));
    };
    return SelectListListElement;
}(React.PureComponent));
exports.default = SelectListListElement;
//# sourceMappingURL=SelectListListElement.js.map