import * as React from 'react';
import { ModalProps } from './Modal';
export interface ChildrenProps {
    onCloseClick: (event?: React.SyntheticEvent<HTMLElement>) => void;
    onFormSubmit: (event: React.SyntheticEvent<HTMLFormElement>) => void;
    onSubmitClick: (event?: React.SyntheticEvent<HTMLElement>) => void;
    submitting: boolean;
}
interface Props extends ModalProps {
    children: (props: ChildrenProps) => React.ReactNode;
    header: string;
    onClose: () => void;
    onSubmit: () => void | Promise<void | Response>;
}
interface State {
    submitting: boolean;
}
export default class SimpleModal extends React.Component<Props, State> {
    mounted: boolean;
    state: State;
    componentDidMount(): void;
    componentWillUnmount(): void;
    stopSubmitting: () => void;
    handleCloseClick: (event?: React.SyntheticEvent<HTMLElement, Event> | undefined) => void;
    handleFormSubmit: (event: React.SyntheticEvent<HTMLFormElement, Event>) => void;
    handleSubmitClick: (event?: React.SyntheticEvent<HTMLElement, Event> | undefined) => void;
    submit: () => void;
    render(): JSX.Element;
}
export {};
