"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var Modal_1 = require("./Modal");
var SimpleModal = (function (_super) {
    __extends(SimpleModal, _super);
    function SimpleModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mounted = false;
        _this.state = { submitting: false };
        _this.stopSubmitting = function () {
            if (_this.mounted) {
                _this.setState({ submitting: false });
            }
        };
        _this.handleCloseClick = function (event) {
            if (event) {
                event.preventDefault();
                event.currentTarget.blur();
            }
            _this.props.onClose();
        };
        _this.handleFormSubmit = function (event) {
            event.preventDefault();
            _this.submit();
        };
        _this.handleSubmitClick = function (event) {
            if (event) {
                event.preventDefault();
                event.currentTarget.blur();
            }
            _this.submit();
        };
        _this.submit = function () {
            var result = _this.props.onSubmit();
            if (result) {
                _this.setState({ submitting: true });
                result.then(_this.stopSubmitting, _this.stopSubmitting);
            }
        };
        return _this;
    }
    SimpleModal.prototype.componentDidMount = function () {
        this.mounted = true;
    };
    SimpleModal.prototype.componentWillUnmount = function () {
        this.mounted = false;
    };
    SimpleModal.prototype.render = function () {
        var _a = this.props, children = _a.children, header = _a.header, onClose = _a.onClose, onSubmit = _a.onSubmit, modalProps = __rest(_a, ["children", "header", "onClose", "onSubmit"]);
        return (React.createElement(Modal_1.default, __assign({ contentLabel: header, onRequestClose: onClose }, modalProps), children({
            onCloseClick: this.handleCloseClick,
            onFormSubmit: this.handleFormSubmit,
            onSubmitClick: this.handleSubmitClick,
            submitting: this.state.submitting,
        })));
    };
    return SimpleModal;
}(React.Component));
exports.default = SimpleModal;
//# sourceMappingURL=SimpleModal.js.map