import * as React from 'react';
import './Tabs.css';
interface Props<T extends string> {
    onChange: (tab: T) => void;
    selected?: T;
    tabs: Array<{
        disabled?: boolean;
        key: T;
        node: React.ReactNode;
    }>;
}
export default function Tabs<T extends string>({ onChange, selected, tabs }: Props<T>): JSX.Element;
interface TabProps<T> {
    children: React.ReactNode;
    disabled?: boolean;
    name: T;
    onSelect: (tab: T) => void;
    selected: boolean;
}
export declare class Tab<T> extends React.PureComponent<TabProps<T>> {
    handleClick: (event: React.MouseEvent<HTMLAnchorElement, MouseEvent>) => void;
    render(): JSX.Element;
}
export {};
