"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var CheckIcon_1 = require("../icons/CheckIcon");
var buttons_1 = require("./buttons");
require("./Toggle.css");
var Toggle = (function (_super) {
    __extends(Toggle, _super);
    function Toggle() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.getValue = function () {
            var value = _this.props.value;
            return typeof value === 'string' ? value === 'true' : value;
        };
        _this.handleClick = function () {
            if (_this.props.onChange) {
                var value = _this.getValue();
                _this.props.onChange(!value);
            }
        };
        return _this;
    }
    Toggle.prototype.render = function () {
        var _a = this.props, disabled = _a.disabled, name = _a.name;
        var value = this.getValue();
        var className = classNames('boolean-toggle', { 'boolean-toggle-on': value });
        return (React.createElement(buttons_1.Button, { className: className, disabled: disabled, name: name, onClick: this.handleClick },
            React.createElement("div", { "aria-label": l10n_1.translate(value ? 'on' : 'off'), className: "boolean-toggle-handle" },
                React.createElement(CheckIcon_1.default, { size: 12 }))));
    };
    return Toggle;
}(React.PureComponent));
exports.default = Toggle;
//# sourceMappingURL=Toggle.js.map