"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var React = require("react");
var react_dom_1 = require("react-dom");
var theme_1 = require("../theme");
var ScreenPositionFixer_1 = require("./ScreenPositionFixer");
require("./Tooltip.css");
var FLIP_MAP = {
    left: 'right',
    right: 'left',
    top: 'bottom',
    bottom: 'top',
};
function isMeasured(state) {
    return state.height !== undefined;
}
function Tooltip(props) {
    return props.overlay != null && props.overlay !== '' ? (React.createElement(TooltipInner, __assign({}, props))) : (props.children);
}
exports.default = Tooltip;
var TooltipInner = (function (_super) {
    __extends(TooltipInner, _super);
    function TooltipInner(props) {
        var _this = _super.call(this, props) || this;
        _this.mounted = false;
        _this.mouseIn = false;
        _this.addEventListeners = function () {
            window.addEventListener('resize', _this.throttledPositionTooltip);
            window.addEventListener('scroll', _this.throttledPositionTooltip);
        };
        _this.removeEventListeners = function () {
            window.removeEventListener('resize', _this.throttledPositionTooltip);
            window.removeEventListener('scroll', _this.throttledPositionTooltip);
        };
        _this.clearTimeouts = function () {
            window.clearTimeout(_this.mouseEnterTimeout);
            window.clearTimeout(_this.mouseLeaveTimeout);
        };
        _this.isVisible = function () {
            return _this.props.visible !== undefined ? _this.props.visible : _this.state.visible;
        };
        _this.getPlacement = function () {
            return _this.state.placement || 'bottom';
        };
        _this.tooltipNodeRef = function (node) {
            _this.tooltipNode = node;
        };
        _this.adjustArrowPosition = function (placement, _a) {
            var leftFix = _a.leftFix, topFix = _a.topFix;
            switch (placement) {
                case 'left':
                case 'right':
                    return { marginTop: -topFix };
                default:
                    return { marginLeft: -leftFix };
            }
        };
        _this.positionTooltip = function () {
            var toggleNode = react_dom_1.findDOMNode(_this);
            if (toggleNode && toggleNode instanceof Element && _this.tooltipNode) {
                var toggleRect = toggleNode.getBoundingClientRect();
                var tooltipRect = _this.tooltipNode.getBoundingClientRect();
                var width = tooltipRect.width, height = tooltipRect.height;
                var left = 0;
                var top_1 = 0;
                switch (_this.getPlacement()) {
                    case 'bottom':
                        left = toggleRect.left + toggleRect.width / 2 - width / 2;
                        top_1 = toggleRect.top + toggleRect.height;
                        break;
                    case 'top':
                        left = toggleRect.left + toggleRect.width / 2 - width / 2;
                        top_1 = toggleRect.top - height;
                        break;
                    case 'right':
                        left = toggleRect.left + toggleRect.width;
                        top_1 = toggleRect.top + toggleRect.height / 2 - height / 2;
                        break;
                    case 'left':
                        left = toggleRect.left - width;
                        top_1 = toggleRect.top + toggleRect.height / 2 - height / 2;
                        break;
                }
                _this.setState({
                    left: window.pageXOffset + left,
                    top: window.pageYOffset + top_1,
                    width: width,
                    height: height,
                });
            }
        };
        _this.clearPosition = function () {
            _this.setState({
                flipped: false,
                left: undefined,
                top: undefined,
                width: undefined,
                height: undefined,
                placement: _this.props.placement,
            });
        };
        _this.handleMouseEnter = function () {
            _this.mouseEnterTimeout = window.setTimeout(function () {
                if (_this.mounted &&
                    _this.props.visible === undefined &&
                    _this.mouseEnterTimeout !== undefined) {
                    _this.setState({ visible: true });
                }
            }, (_this.props.mouseEnterDelay || 0) * 1000);
            if (_this.props.onShow) {
                _this.props.onShow();
            }
        };
        _this.handleMouseLeave = function () {
            if (_this.mouseEnterTimeout !== undefined) {
                window.clearTimeout(_this.mouseEnterTimeout);
                _this.mouseEnterTimeout = undefined;
            }
            if (!_this.mouseIn) {
                _this.mouseLeaveTimeout = window.setTimeout(function () {
                    if (_this.mounted && _this.props.visible === undefined && !_this.mouseIn) {
                        _this.setState({ visible: false });
                    }
                }, (_this.props.mouseLeaveDelay || 0) * 1000);
                if (_this.props.onHide) {
                    _this.props.onHide();
                }
            }
        };
        _this.handleOverlayMouseEnter = function () {
            _this.mouseIn = true;
        };
        _this.handleOverlayMouseLeave = function () {
            _this.mouseIn = false;
            _this.handleMouseLeave();
        };
        _this.needsFlipping = function (leftFix, topFix) {
            var threshold = _this.context.rawSizes.grid;
            switch (_this.getPlacement()) {
                case 'left':
                case 'right':
                    return Math.abs(leftFix) > threshold;
                case 'top':
                case 'bottom':
                    return Math.abs(topFix) > threshold;
            }
            return false;
        };
        _this.renderActual = function (_a) {
            var _b = _a.leftFix, leftFix = _b === void 0 ? 0 : _b, _c = _a.topFix, topFix = _c === void 0 ? 0 : _c;
            if (!_this.state.flipped &&
                (leftFix !== 0 || topFix !== 0) &&
                _this.needsFlipping(leftFix, topFix)) {
                setTimeout(function () {
                    _this.setState(function (_a) {
                        var _b = _a.placement, placement = _b === void 0 ? 'bottom' : _b;
                        return ({
                            flipped: true,
                            height: undefined,
                            placement: FLIP_MAP[placement],
                        });
                    }, function () {
                        if (_this.state.visible) {
                            _this.positionTooltip();
                        }
                    });
                }, 1);
                return null;
            }
            var _d = _this.props.classNameSpace, classNameSpace = _d === void 0 ? 'tooltip' : _d;
            var placement = _this.getPlacement();
            var style = isMeasured(_this.state)
                ? {
                    left: _this.state.left + leftFix,
                    top: _this.state.top + topFix,
                    width: _this.state.width,
                    height: _this.state.height,
                }
                : undefined;
            return (React.createElement("div", { className: classNameSpace + " " + placement, onMouseEnter: _this.handleOverlayMouseEnter, onMouseLeave: _this.handleOverlayMouseLeave, ref: _this.tooltipNodeRef, style: style },
                React.createElement("div", { className: classNameSpace + "-inner" }, _this.props.overlay),
                React.createElement("div", { className: classNameSpace + "-arrow", style: isMeasured(_this.state)
                        ? _this.adjustArrowPosition(placement, { leftFix: leftFix, topFix: topFix })
                        : undefined })));
        };
        _this.state = {
            flipped: false,
            placement: props.placement,
            visible: props.visible !== undefined ? props.visible : false,
        };
        _this.throttledPositionTooltip = lodash_1.throttle(_this.positionTooltip, 10);
        return _this;
    }
    TooltipInner.prototype.componentDidMount = function () {
        this.mounted = true;
        if (this.props.visible === true) {
            this.positionTooltip();
            this.addEventListeners();
        }
    };
    TooltipInner.prototype.componentDidUpdate = function (prevProps, prevState) {
        if (this.props.placement !== prevProps.placement) {
            this.setState({ placement: this.props.placement });
            return;
        }
        if ((this.props.visible === true && !prevProps.visible) ||
            (this.props.visible === undefined &&
                this.state.visible === true &&
                prevState.visible === false)) {
            this.positionTooltip();
            this.addEventListeners();
        }
        else if ((!this.props.visible && prevProps.visible === true) ||
            (this.props.visible === undefined &&
                this.state.visible === false &&
                prevState.visible === true)) {
            this.clearPosition();
            this.removeEventListeners();
        }
    };
    TooltipInner.prototype.componentWillUnmount = function () {
        this.mounted = false;
        this.removeEventListeners();
        this.clearTimeouts();
    };
    TooltipInner.prototype.render = function () {
        return (React.createElement(React.Fragment, null,
            React.cloneElement(this.props.children, {
                onMouseEnter: this.handleMouseEnter,
                onMouseLeave: this.handleMouseLeave,
            }),
            this.isVisible() && (React.createElement(TooltipPortal, null,
                React.createElement(ScreenPositionFixer_1.default, { ready: isMeasured(this.state) }, this.renderActual)))));
    };
    TooltipInner.defaultProps = {
        mouseEnterDelay: 0.1,
    };
    TooltipInner.contextType = theme_1.default;
    return TooltipInner;
}(React.Component));
exports.TooltipInner = TooltipInner;
var TooltipPortal = (function (_super) {
    __extends(TooltipPortal, _super);
    function TooltipPortal(props) {
        var _this = _super.call(this, props) || this;
        _this.el = document.createElement('div');
        return _this;
    }
    TooltipPortal.prototype.componentDidMount = function () {
        document.body.appendChild(this.el);
    };
    TooltipPortal.prototype.componentWillUnmount = function () {
        document.body.removeChild(this.el);
    };
    TooltipPortal.prototype.render = function () {
        return react_dom_1.createPortal(this.props.children, this.el);
    };
    return TooltipPortal;
}(React.Component));
//# sourceMappingURL=Tooltip.js.map