import { FormikActions, FormikProps } from 'formik';
import * as React from 'react';
export declare type ChildrenProps<V> = T.Omit<FormikProps<V>, 'handleSubmit'>;
interface Props<V> {
    children: (props: ChildrenProps<V>) => React.ReactNode;
    initialValues: V;
    isInitialValid?: boolean;
    onSubmit: (data: V) => Promise<void>;
    validate: (data: V) => {
        [P in keyof V]?: string;
    } | Promise<{
        [P in keyof V]?: string;
    }>;
}
export default class ValidationForm<V> extends React.Component<Props<V>> {
    mounted: boolean;
    componentDidMount(): void;
    componentWillUnmount(): void;
    handleSubmit: (data: V, { setSubmitting }: FormikActions<V>) => void;
    render(): JSX.Element;
}
export {};
