"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var AlertErrorIcon_1 = require("../icons/AlertErrorIcon");
var AlertSuccessIcon_1 = require("../icons/AlertSuccessIcon");
var HelpTooltip_1 = require("./HelpTooltip");
function ValidationInput(props) {
    var hasError = props.isInvalid && props.error !== undefined;
    return (React.createElement("div", { className: props.className },
        React.createElement("label", { htmlFor: props.id },
            React.createElement("span", { className: "text-middle" },
                React.createElement("strong", null, props.label),
                props.required && React.createElement("em", { className: "mandatory" }, "*")),
            props.help && React.createElement(HelpTooltip_1.default, { className: "spacer-left", overlay: props.help })),
        React.createElement("div", { className: "little-spacer-top spacer-bottom" },
            props.children,
            props.isInvalid && React.createElement(AlertErrorIcon_1.default, { className: "spacer-left text-middle" }),
            hasError && (React.createElement("span", { className: "little-spacer-left text-danger text-middle" }, props.error)),
            props.isValid && React.createElement(AlertSuccessIcon_1.default, { className: "spacer-left text-middle" })),
        props.description && React.createElement("div", { className: "note abs-width-400" }, props.description)));
}
exports.default = ValidationInput;
//# sourceMappingURL=ValidationInput.js.map