"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var DeferredSpinner_1 = require("../ui/DeferredSpinner");
var buttons_1 = require("./buttons");
var Modal_1 = require("./Modal");
var ValidationForm_1 = require("./ValidationForm");
var ValidationModal = (function (_super) {
    __extends(ValidationModal, _super);
    function ValidationModal() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleSubmit = function (data) {
            return _this.props.onSubmit(data).then(function () {
                _this.props.onClose();
            });
        };
        return _this;
    }
    ValidationModal.prototype.render = function () {
        var _this = this;
        return (React.createElement(Modal_1.default, { contentLabel: this.props.header, noBackdrop: this.props.noBackdrop, onRequestClose: this.props.onClose, size: this.props.size },
            React.createElement(ValidationForm_1.default, { initialValues: this.props.initialValues, isInitialValid: this.props.isInitialValid, onSubmit: this.handleSubmit, validate: this.props.validate }, function (props) { return (React.createElement(React.Fragment, null,
                React.createElement("header", { className: "modal-head" },
                    React.createElement("h2", null, _this.props.header)),
                React.createElement("div", { className: "modal-body" }, _this.props.children(props)),
                React.createElement("footer", { className: "modal-foot" },
                    React.createElement(DeferredSpinner_1.default, { className: "spacer-right", loading: props.isSubmitting }),
                    React.createElement(buttons_1.SubmitButton, { className: _this.props.isDestructive ? 'button-red' : undefined, disabled: props.isSubmitting || !props.isValid || !props.dirty }, _this.props.confirmButtonText),
                    React.createElement(buttons_1.ResetButtonLink, { disabled: props.isSubmitting, onClick: _this.props.onClose }, l10n_1.translate('cancel'))))); })));
    };
    return ValidationModal;
}(React.PureComponent));
exports.default = ValidationModal;
//# sourceMappingURL=ValidationModal.js.map