"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var ChevronRightIcon_1 = require("../icons/ChevronRightIcon");
var ClearIcon_1 = require("../icons/ClearIcon");
var DeleteIcon_1 = require("../icons/DeleteIcon");
var EditIcon_1 = require("../icons/EditIcon");
var theme_1 = require("../theme");
require("./buttons.css");
var Tooltip_1 = require("./Tooltip");
var Button = (function (_super) {
    __extends(Button, _super);
    function Button() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.handleClick = function (event) {
            var _a = _this.props, disabled = _a.disabled, onClick = _a.onClick, _b = _a.preventDefault, preventDefault = _b === void 0 ? true : _b, _c = _a.stopPropagation, stopPropagation = _c === void 0 ? false : _c;
            event.currentTarget.blur();
            if (preventDefault || disabled) {
                event.preventDefault();
            }
            if (stopPropagation) {
                event.stopPropagation();
            }
            if (onClick && !disabled) {
                onClick();
            }
        };
        return _this;
    }
    Button.prototype.render = function () {
        var _a = this.props, className = _a.className, disabled = _a.disabled, innerRef = _a.innerRef, onClick = _a.onClick, preventDefault = _a.preventDefault, stopPropagation = _a.stopPropagation, _b = _a.type, type = _b === void 0 ? 'button' : _b, props = __rest(_a, ["className", "disabled", "innerRef", "onClick", "preventDefault", "stopPropagation", "type"]);
        return (React.createElement("button", __assign({}, props, { "aria-disabled": disabled, className: classNames('button', className, { disabled: disabled }), id: this.props.id, onClick: this.handleClick, ref: this.props.innerRef, type: type })));
    };
    return Button;
}(React.PureComponent));
exports.Button = Button;
function ButtonLink(_a) {
    var className = _a.className, props = __rest(_a, ["className"]);
    return React.createElement(Button, __assign({}, props, { className: classNames('button-link', className) }));
}
exports.ButtonLink = ButtonLink;
function SubmitButton(props) {
    return React.createElement(Button, __assign({}, props, { preventDefault: false, type: "submit" }));
}
exports.SubmitButton = SubmitButton;
function ResetButtonLink(props) {
    return React.createElement(ButtonLink, __assign({}, props, { type: "reset" }));
}
exports.ResetButtonLink = ResetButtonLink;
function ButtonIcon(props) {
    var className = props.className, color = props.color, tooltip = props.tooltip, tooltipProps = props.tooltipProps, other = __rest(props, ["className", "color", "tooltip", "tooltipProps"]);
    return (React.createElement(theme_1.ThemeConsumer, null, function (theme) { return (React.createElement(Tooltip_1.default, __assign({ mouseEnterDelay: 0.4, overlay: tooltip }, tooltipProps),
        React.createElement(Button, __assign({ className: classNames(className, 'button-icon'), stopPropagation: true, style: { color: color || theme.colors.darkBlue } }, other)))); }));
}
exports.ButtonIcon = ButtonIcon;
function ClearButton(_a) {
    var color = _a.color, _b = _a.iconProps, iconProps = _b === void 0 ? {} : _b, props = __rest(_a, ["color", "iconProps"]);
    return (React.createElement(theme_1.ThemeConsumer, null, function (theme) { return (React.createElement(ButtonIcon, __assign({ color: color || theme.colors.gray60 }, props),
        React.createElement(ClearIcon_1.default, __assign({}, iconProps)))); }));
}
exports.ClearButton = ClearButton;
function DeleteButton(_a) {
    var _b = _a.iconProps, iconProps = _b === void 0 ? {} : _b, props = __rest(_a, ["iconProps"]);
    return (React.createElement(theme_1.ThemeConsumer, null, function (theme) { return (React.createElement(ButtonIcon, __assign({ color: theme.colors.red }, props),
        React.createElement(DeleteIcon_1.default, __assign({}, iconProps)))); }));
}
exports.DeleteButton = DeleteButton;
function EditButton(_a) {
    var _b = _a.iconProps, iconProps = _b === void 0 ? {} : _b, props = __rest(_a, ["iconProps"]);
    return (React.createElement(ButtonIcon, __assign({}, props),
        React.createElement(EditIcon_1.default, __assign({}, iconProps))));
}
exports.EditButton = EditButton;
function ListButton(_a) {
    var className = _a.className, children = _a.children, props = __rest(_a, ["className", "children"]);
    return (React.createElement(Button, __assign({ className: classNames('button-list', className) }, props),
        children,
        React.createElement(ChevronRightIcon_1.default, null)));
}
exports.ListButton = ListButton;
//# sourceMappingURL=buttons.js.map