import * as React from 'react';
export interface State {
    copySuccess: boolean;
}
interface RenderProps {
    setCopyButton: (node: HTMLElement | null) => void;
    copySuccess: boolean;
}
interface BaseProps {
    children: (props: RenderProps) => React.ReactNode;
}
export declare class ClipboardBase extends React.PureComponent<BaseProps, State> {
    private clipboard?;
    private copyButton?;
    mounted: boolean;
    state: State;
    componentDidMount(): void;
    componentDidUpdate(): void;
    componentWillUnmount(): void;
    setCopyButton: (node: HTMLElement | null) => void;
    handleSuccessCopy: () => void;
    render(): React.ReactNode;
}
interface ButtonProps {
    className?: string;
    copyValue: string;
    children?: React.ReactNode;
}
export declare function ClipboardButton({ className, children, copyValue }: ButtonProps): JSX.Element;
interface IconButtonProps {
    'aria-label'?: string;
    className?: string;
    copyValue: string;
}
export declare function ClipboardIconButton(props: IconButtonProps): JSX.Element;
export {};
