"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var Clipboard = require("clipboard");
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var CopyIcon_1 = require("../icons/CopyIcon");
var buttons_1 = require("./buttons");
var Tooltip_1 = require("./Tooltip");
var ClipboardBase = (function (_super) {
    __extends(ClipboardBase, _super);
    function ClipboardBase() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mounted = false;
        _this.state = { copySuccess: false };
        _this.setCopyButton = function (node) {
            _this.copyButton = node;
        };
        _this.handleSuccessCopy = function () {
            if (_this.mounted) {
                _this.setState({ copySuccess: true });
                setTimeout(function () {
                    if (_this.mounted) {
                        _this.setState({ copySuccess: false });
                    }
                }, 1000);
            }
        };
        return _this;
    }
    ClipboardBase.prototype.componentDidMount = function () {
        this.mounted = true;
        if (this.copyButton) {
            this.clipboard = new Clipboard(this.copyButton);
            this.clipboard.on('success', this.handleSuccessCopy);
        }
    };
    ClipboardBase.prototype.componentDidUpdate = function () {
        if (this.clipboard) {
            this.clipboard.destroy();
        }
        if (this.copyButton) {
            this.clipboard = new Clipboard(this.copyButton);
            this.clipboard.on('success', this.handleSuccessCopy);
        }
    };
    ClipboardBase.prototype.componentWillUnmount = function () {
        this.mounted = false;
        if (this.clipboard) {
            this.clipboard.destroy();
        }
    };
    ClipboardBase.prototype.render = function () {
        return this.props.children({
            setCopyButton: this.setCopyButton,
            copySuccess: this.state.copySuccess,
        });
    };
    return ClipboardBase;
}(React.PureComponent));
exports.ClipboardBase = ClipboardBase;
function ClipboardButton(_a) {
    var className = _a.className, children = _a.children, copyValue = _a.copyValue;
    return (React.createElement(ClipboardBase, null, function (_a) {
        var setCopyButton = _a.setCopyButton, copySuccess = _a.copySuccess;
        return (React.createElement(Tooltip_1.default, { overlay: l10n_1.translate('copied_action'), visible: copySuccess },
            React.createElement(buttons_1.Button, { className: classNames('no-select', className), "data-clipboard-text": copyValue, innerRef: setCopyButton }, children || (React.createElement(React.Fragment, null,
                React.createElement(CopyIcon_1.default, { className: "little-spacer-right" }),
                l10n_1.translate('copy'))))));
    }));
}
exports.ClipboardButton = ClipboardButton;
function ClipboardIconButton(props) {
    var className = props.className, copyValue = props.copyValue;
    return (React.createElement(ClipboardBase, null, function (_a) {
        var setCopyButton = _a.setCopyButton, copySuccess = _a.copySuccess;
        var _b;
        return (React.createElement(buttons_1.ButtonIcon, { "aria-label": (_b = props['aria-label']) !== null && _b !== void 0 ? _b : l10n_1.translate('copy_to_clipboard'), className: classNames('no-select', className), "data-clipboard-text": copyValue, innerRef: setCopyButton, tooltip: l10n_1.translate(copySuccess ? 'copied_action' : 'copy_to_clipboard'), tooltipProps: copySuccess ? { visible: copySuccess } : undefined },
            React.createElement(CopyIcon_1.default, null)));
    }));
}
exports.ClipboardIconButton = ClipboardIconButton;
//# sourceMappingURL=clipboard.js.map