import * as React from 'react';
import { Theme } from '../theme';
export interface IconProps extends React.AriaAttributes {
    className?: string;
    fill?: string;
    size?: number;
}
interface Props extends React.AriaAttributes {
    children: React.ReactNode;
    className?: string;
    size?: number;
    style?: React.CSSProperties;
    width?: number;
    height?: number;
    viewBox?: string;
}
export default function Icon({ children, className, size, style, height, width, viewBox, ...iconProps }: Props): JSX.Element;
interface ThemedProps extends Props {
    children: (themeContext: {
        theme: Theme;
    }) => React.ReactNode;
}
export declare function ThemedIcon({ children, ...iconProps }: ThemedProps): JSX.Element;
export {};
