"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var date_fns_1 = require("date-fns");
var React = require("react");
var react_intl_1 = require("react-intl");
var dates_1 = require("../../helpers/dates");
var l10n_1 = require("../../helpers/l10n");
var DateTimeFormatter_1 = require("./DateTimeFormatter");
function DateFromNow(props) {
    var _a = props.children, originalChildren = _a === void 0 ? function (f) { return f; } : _a, date = props.date, hourPrecision = props.hourPrecision;
    var children = originalChildren;
    if (!date) {
        return React.createElement(React.Fragment, null, originalChildren(l10n_1.translate('never')));
    }
    if (date && hourPrecision && date_fns_1.differenceInHours(Date.now(), date) < 1) {
        children = function () { return originalChildren(l10n_1.translate('less_than_1_hour_ago')); };
    }
    var parsedDate = dates_1.parseDate(date);
    return (React.createElement(DateTimeFormatter_1.default, { date: parsedDate }, function (formattedDate) { return (React.createElement("span", { title: formattedDate },
        React.createElement(react_intl_1.FormattedRelative, { value: parsedDate }, children))); }));
}
exports.default = DateFromNow;
//# sourceMappingURL=DateFromNow.js.map