"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var init_1 = require("../helpers/init");
var l10n_1 = require("../helpers/l10n");
var request_1 = require("../helpers/request");
var Alert_1 = require("./ui/Alert");
function lazyLoadComponent(factory, displayName) {
    var LazyComponent = React.lazy(function () {
        return request_1.requestTryAndRepeatUntil(factory, { max: 2, slowThreshold: 2 }, function () { return true; });
    });
    function LazyComponentWrapper(props) {
        if (init_1.IS_SSR) {
            return null;
        }
        return (React.createElement(LazyErrorBoundary, null,
            React.createElement(React.Suspense, { fallback: null },
                React.createElement(LazyComponent, __assign({}, props)))));
    }
    LazyComponentWrapper.displayName = displayName;
    return LazyComponentWrapper;
}
exports.lazyLoadComponent = lazyLoadComponent;
var LazyErrorBoundary = (function (_super) {
    __extends(LazyErrorBoundary, _super);
    function LazyErrorBoundary() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { hasError: false };
        return _this;
    }
    LazyErrorBoundary.getDerivedStateFromError = function () {
        return { hasError: true };
    };
    LazyErrorBoundary.prototype.render = function () {
        if (this.state.hasError) {
            return React.createElement(Alert_1.Alert, { variant: "error" }, l10n_1.translate('default_error_message'));
        }
        return this.props.children;
    };
    return LazyErrorBoundary;
}(React.Component));
exports.LazyErrorBoundary = LazyErrorBoundary;
//# sourceMappingURL=lazyLoadComponent.js.map