import { css } from '@emotion/core';
import { CreateStyled } from '@emotion/styled';
import { ThemeProviderProps, withTheme } from 'emotion-theming';
import * as React from 'react';
export interface Theme {
    colors: T.Dict<string>;
    sizes: T.Dict<string>;
    rawSizes: T.Dict<number>;
    fonts: T.Dict<string>;
    zIndexes: T.Dict<string>;
    others: T.Dict<string>;
}
export interface ThemedProps {
    theme: Theme;
}
declare const ThemeContext: React.Context<Theme>;
export declare const styled: CreateStyled<Theme>;
export declare const ThemeConsumer: React.Consumer<Theme>;
export declare const ThemeProvider: React.ProviderExoticComponent<ThemeProviderProps<Theme>>;
export declare const useTheme: () => Theme;
export declare function themeGet(type: keyof Theme, name: string | number): ({ theme }: Partial<ThemedProps>) => string | number | undefined;
export declare function themeColor(name: keyof Theme['colors']): ({ theme }: Partial<ThemedProps>) => string | number | undefined;
export declare function themeSize(name: keyof Theme['sizes']): ({ theme }: Partial<ThemedProps>) => string | number | undefined;
export { css, withTheme };
export default ThemeContext;
