"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var core_1 = require("@emotion/core");
exports.css = core_1.css;
var styled_1 = require("@emotion/styled");
var emotion_theming_1 = require("emotion-theming");
exports.withTheme = emotion_theming_1.withTheme;
var ThemeContext = core_1.ThemeContext;
exports.styled = styled_1.default;
exports.ThemeConsumer = ThemeContext.Consumer;
exports.ThemeProvider = emotion_theming_1.ThemeProvider;
exports.useTheme = emotion_theming_1.useTheme;
function themeGet(type, name) {
    return function (_a) {
        var theme = _a.theme;
        return theme === null || theme === void 0 ? void 0 : theme[type][name];
    };
}
exports.themeGet = themeGet;
function themeColor(name) {
    return themeGet('colors', name);
}
exports.themeColor = themeColor;
function themeSize(name) {
    return themeGet('sizes', name);
}
exports.themeSize = themeSize;
exports.default = ThemeContext;
//# sourceMappingURL=theme.js.map