"use strict";
var __makeTemplateObject = (this && this.__makeTemplateObject) || function (cooked, raw) {
    if (Object.defineProperty) { Object.defineProperty(cooked, "raw", { value: raw }); } else { cooked.raw = raw; }
    return cooked;
};
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var AlertErrorIcon_1 = require("../icons/AlertErrorIcon");
var AlertSuccessIcon_1 = require("../icons/AlertSuccessIcon");
var AlertWarnIcon_1 = require("../icons/AlertWarnIcon");
var InfoIcon_1 = require("../icons/InfoIcon");
var theme_1 = require("../theme");
var DeferredSpinner_1 = require("./DeferredSpinner");
var StyledAlertIcon = theme_1.styled.div(templateObject_1 || (templateObject_1 = __makeTemplateObject(["\n  flex: 0 0 auto;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  width: calc(", " * ", ");\n  border-right: ", ";\n  border-color: ", ";\n"], ["\n  flex: 0 0 auto;\n  display: flex;\n  justify-content: center;\n  align-items: center;\n  width: calc(", " * ", ");\n  border-right: ", ";\n  border-color: ", ";\n"])), function (_a) {
    var isBanner = _a.isBanner;
    return (isBanner ? 2 : 4);
}, theme_1.themeSize('gridSize'), function (_a) {
    var isBanner = _a.isBanner;
    return (!isBanner ? '1px solid' : 'none');
}, function (_a) {
    var variantInfo = _a.variantInfo;
    return variantInfo.borderColor;
});
var StyledAlertContent = theme_1.styled.div(templateObject_2 || (templateObject_2 = __makeTemplateObject(["\n  flex: 1 1 auto;\n  overflow: auto;\n  text-align: left;\n  padding: ", " calc(2 * ", ");\n"], ["\n  flex: 1 1 auto;\n  overflow: auto;\n  text-align: left;\n  padding: ", " calc(2 * ", ");\n"])), theme_1.themeSize('gridSize'), theme_1.themeSize('gridSize'));
var alertInnerIsBannerMixin = function (_a) {
    var theme = _a.theme;
    return theme_1.css(templateObject_3 || (templateObject_3 = __makeTemplateObject(["\n  min-width: ", ";\n  max-width: ", ";\n  margin-left: auto;\n  margin-right: auto;\n  padding-left: ", ";\n  padding-right: ", ";\n  box-sizing: border-box;\n"], ["\n  min-width: ", ";\n  max-width: ", ";\n  margin-left: auto;\n  margin-right: auto;\n  padding-left: ", ";\n  padding-right: ", ";\n  box-sizing: border-box;\n"])), theme.sizes.minPageWidth, theme.sizes.maxPageWidth, theme.sizes.pagePadding, theme.sizes.pagePadding);
};
var StyledAlertInner = theme_1.styled.div(templateObject_4 || (templateObject_4 = __makeTemplateObject(["\n  display: flex;\n  align-items: stretch;\n  ", "\n"], ["\n  display: flex;\n  align-items: stretch;\n  ", "\n"])), function (_a) {
    var isBanner = _a.isBanner;
    return (isBanner ? alertInnerIsBannerMixin : null);
});
var StyledAlert = theme_1.styled.div(templateObject_5 || (templateObject_5 = __makeTemplateObject(["\n  border: 1px solid;\n  border-radius: 2px;\n  margin-bottom: ", ";\n  border-color: ", ";\n  background-color: ", ";\n  color: ", ";\n  display: ", ";\n\n  :empty {\n    display: none;\n  }\n\n  a,\n  .button-link {\n    border-color: ", ";\n  }\n"], ["\n  border: 1px solid;\n  border-radius: 2px;\n  margin-bottom: ", ";\n  border-color: ", ";\n  background-color: ", ";\n  color: ", ";\n  display: ", ";\n\n  :empty {\n    display: none;\n  }\n\n  a,\n  .button-link {\n    border-color: ", ";\n  }\n"])), theme_1.themeSize('gridSize'), function (_a) {
    var variantInfo = _a.variantInfo;
    return variantInfo.borderColor;
}, function (_a) {
    var variantInfo = _a.variantInfo;
    return variantInfo.backGroundColor;
}, function (_a) {
    var variantInfo = _a.variantInfo;
    return variantInfo.color;
}, function (_a) {
    var isInline = _a.isInline;
    return (isInline ? 'inline-block' : 'block');
}, theme_1.themeColor('darkBlue'));
function getAlertVariantInfo(_a, variant) {
    var colors = _a.colors;
    var variantList = {
        error: {
            icon: React.createElement(AlertErrorIcon_1.default, { fill: colors.alertIconError }),
            color: colors.alertTextError,
            borderColor: colors.alertBorderError,
            backGroundColor: colors.alertBackgroundError,
        },
        warning: {
            icon: React.createElement(AlertWarnIcon_1.default, { fill: colors.alertIconWarning }),
            color: colors.alertTextWarning,
            borderColor: colors.alertBorderWarning,
            backGroundColor: colors.alertBackgroundWarning,
        },
        success: {
            icon: React.createElement(AlertSuccessIcon_1.default, { fill: colors.alertIconSuccess }),
            color: colors.alertTextSuccess,
            borderColor: colors.alertBorderSuccess,
            backGroundColor: colors.alertBackgroundSuccess,
        },
        info: {
            icon: React.createElement(InfoIcon_1.default, { fill: colors.alertIconInfo }),
            color: colors.alertTextInfo,
            borderColor: colors.alertBorderInfo,
            backGroundColor: colors.alertBackgroundInfo,
        },
        loading: {
            icon: React.createElement(DeferredSpinner_1.default, { timeout: 0 }),
            color: colors.alertTextInfo,
            borderColor: colors.alertBorderInfo,
            backGroundColor: colors.alertBackgroundInfo,
        },
    };
    return variantList[variant];
}
function Alert(props) {
    var theme = theme_1.useTheme();
    var className = props.className, display = props.display, variant = props.variant, domProps = __rest(props, ["className", "display", "variant"]);
    var isInline = display === 'inline';
    var isBanner = display === 'banner';
    var variantInfo = getAlertVariantInfo(theme, variant);
    return (React.createElement(StyledAlert, __assign({ className: classNames('alert', className), isInline: isInline, role: "alert", variantInfo: variantInfo }, domProps),
        React.createElement(StyledAlertInner, { isBanner: isBanner },
            React.createElement(StyledAlertIcon, { "aria-label": l10n_1.translate('alert.tooltip', variant), isBanner: isBanner, variantInfo: variantInfo }, variantInfo.icon),
            React.createElement(StyledAlertContent, { className: "alert-content" }, props.children))));
}
exports.Alert = Alert;
var templateObject_1, templateObject_2, templateObject_3, templateObject_4, templateObject_5;
//# sourceMappingURL=Alert.js.map