"use strict";
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = require("classnames");
var React = require("react");
function AutoEllipsis(props) {
    var children = props.children, autoEllipsisProps = __rest(props, ["children"]);
    var _a = useAutoEllipsis(autoEllipsisProps), autoEllispis = _a[0], ref = _a[1];
    return React.cloneElement(children, {
        className: classnames_1.default(children.props.className, { 'text-ellipsis': autoEllispis }),
        ref: ref,
    });
}
exports.default = AutoEllipsis;
function useAutoEllipsis(props) {
    var _a = React.useState(false), autoEllipsis = _a[0], setAutoEllipsis = _a[1];
    var ref = React.useCallback(function (node) {
        var _a;
        if (!autoEllipsis && node) {
            var shouldEllipsis = (_a = props.customShouldEllipsis) !== null && _a !== void 0 ? _a : exports.defaultShouldEllipsis;
            setAutoEllipsis(shouldEllipsis(node, props));
        }
    }, [props.customShouldEllipsis, props.maxHeight, props.maxWidth, props.useParent]);
    return [autoEllipsis, ref];
}
exports.useAutoEllipsis = useAutoEllipsis;
exports.defaultShouldEllipsis = function (node, _a) {
    var _b = _a.useParent, useParent = _b === void 0 ? true : _b, maxWidth = _a.maxWidth, maxHeight = _a.maxHeight;
    if (node.parentElement && useParent) {
        maxWidth = maxWidth !== null && maxWidth !== void 0 ? maxWidth : node.parentElement.clientWidth;
        maxHeight = maxHeight !== null && maxHeight !== void 0 ? maxHeight : node.parentElement.clientHeight;
    }
    return ((maxWidth !== undefined && node.clientWidth > maxWidth) ||
        (maxHeight !== undefined && node.clientHeight > maxHeight));
};
//# sourceMappingURL=AutoEllipsis.js.map