"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
require("./DeferredSpinner.css");
var DEFAULT_TIMEOUT = 100;
var DeferredSpinner = (function (_super) {
    __extends(DeferredSpinner, _super);
    function DeferredSpinner() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = { showSpinner: false };
        _this.startTimer = function () {
            _this.timer = window.setTimeout(function () { return _this.setState({ showSpinner: true }); }, _this.props.timeout || DEFAULT_TIMEOUT);
        };
        _this.stopTimer = function () {
            window.clearTimeout(_this.timer);
        };
        return _this;
    }
    DeferredSpinner.prototype.componentDidMount = function () {
        if (this.props.loading == null || this.props.loading === true) {
            this.startTimer();
        }
    };
    DeferredSpinner.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.loading === false && this.props.loading === true) {
            this.stopTimer();
            this.startTimer();
        }
        if (prevProps.loading === true && this.props.loading === false) {
            this.stopTimer();
            this.setState({ showSpinner: false });
        }
    };
    DeferredSpinner.prototype.componentWillUnmount = function () {
        this.stopTimer();
    };
    DeferredSpinner.prototype.render = function () {
        if (this.state.showSpinner) {
            return (this.props.customSpinner || (React.createElement("i", { className: classNames('deferred-spinner', this.props.className) })));
        }
        return (this.props.children ||
            (this.props.placeholder ? (React.createElement("i", { className: classNames('deferred-spinner-placeholder', this.props.className) })) : null));
    };
    return DeferredSpinner;
}(React.PureComponent));
exports.default = DeferredSpinner;
//# sourceMappingURL=DeferredSpinner.js.map