"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var colors_1 = require("../../helpers/colors");
function GenericAvatar(_a) {
    var className = _a.className, name = _a.name, round = _a.round, size = _a.size;
    var color = colors_1.stringToColor(name);
    var text = '';
    var words = name.split(/\s+/).filter(function (word) { return word.length > 0; });
    if (words.length >= 2) {
        text = words[0][0] + words[1][0];
    }
    else if (name.length > 0) {
        text = name[0];
    }
    return (React.createElement("div", { className: classNames(className, 'rounded'), style: {
            backgroundColor: color,
            borderRadius: round ? '50%' : undefined,
            color: colors_1.getTextColor(color),
            display: 'inline-block',
            fontSize: Math.min(size / 2, 14),
            fontWeight: 'normal',
            height: size,
            lineHeight: size + "px",
            textAlign: 'center',
            verticalAlign: 'top',
            width: size,
        } }, text.toUpperCase()));
}
exports.default = GenericAvatar;
//# sourceMappingURL=GenericAvatar.js.map