"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var React = require("react");
var l10n_1 = require("../../helpers/l10n");
var measures_1 = require("../../helpers/measures");
require("./Rating.css");
function Rating(_a) {
    var className = _a.className, _b = _a.muted, muted = _b === void 0 ? false : _b, _c = _a.small, small = _c === void 0 ? false : _c, value = _a.value, ariaAttrs = __rest(_a, ["className", "muted", "small", "value"]);
    if (value === undefined) {
        return (React.createElement("span", __assign({ "aria-label": l10n_1.translate('metric.no_rating') }, ariaAttrs), "\u2013"));
    }
    var formatted = measures_1.formatMeasure(value, 'RATING');
    return (React.createElement("span", __assign({ "aria-label": l10n_1.translateWithParameters('metric.has_rating_X', formatted), className: classNames('rating', "rating-" + formatted, { 'rating-small': small, 'rating-muted': muted }, className) }, ariaAttrs), formatted));
}
exports.default = Rating;
//# sourceMappingURL=Rating.js.map