"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var classNames = require("classnames");
var lodash_1 = require("lodash");
var React = require("react");
require("./SizeRating.css");
function SizeRating(_a) {
    var _b = _a.small, small = _b === void 0 ? false : _b, _c = _a.muted, muted = _c === void 0 ? false : _c, value = _a.value;
    if (value == null) {
        return React.createElement("div", { className: "size-rating size-rating-muted" }, "\u00A0");
    }
    var letter;
    if (lodash_1.inRange(value, 0, 1000)) {
        letter = 'XS';
    }
    else if (lodash_1.inRange(value, 1000, 10000)) {
        letter = 'S';
    }
    else if (lodash_1.inRange(value, 10000, 100000)) {
        letter = 'M';
    }
    else if (lodash_1.inRange(value, 100000, 500000)) {
        letter = 'L';
    }
    else if (value >= 500000) {
        letter = 'XL';
    }
    var className = classNames('size-rating', {
        'size-rating-small': small,
        'size-rating-muted': muted,
    });
    return (React.createElement("div", { "aria-hidden": "true", className: className }, letter));
}
exports.default = SizeRating;
//# sourceMappingURL=SizeRating.js.map