"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
require("./MetaData.css");
var MetaDataVersions_1 = require("./MetaDataVersions");
var request_1 = require("../../../helpers/request");
var MetaData = (function (_super) {
    __extends(MetaData, _super);
    function MetaData() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.mounted = false;
        _this.state = {};
        return _this;
    }
    MetaData.prototype.componentDidMount = function () {
        this.mounted = true;
        this.fetchData();
    };
    MetaData.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.updateCenterKey !== this.props.updateCenterKey) {
            this.fetchData();
        }
    };
    MetaData.prototype.componentWillUnmount = function () {
        this.mounted = false;
    };
    MetaData.prototype.fetchData = function () {
        var _this = this;
        var updateCenterKey = this.props.updateCenterKey;
        if (updateCenterKey) {
            window
                .fetch("https://update.sonarsource.org/" + updateCenterKey + ".json")
                .then(function (response) {
                if (request_1.isSuccessStatus(response.status)) {
                    return response.json();
                }
                else {
                    return Promise.reject(response);
                }
            })
                .then(function (data) {
                if (_this.mounted) {
                    _this.setState({ data: data });
                }
            })
                .catch(function () {
                if (_this.mounted) {
                    _this.setState({ data: undefined });
                }
            });
        }
        else {
            this.setState({ data: undefined });
        }
    };
    MetaData.prototype.render = function () {
        var data = this.state.data;
        if (!data) {
            return null;
        }
        var isSonarSourceCommercial = data.isSonarSourceCommercial, issueTrackerURL = data.issueTrackerURL, license = data.license, organization = data.organization, versions = data.versions;
        var vendor;
        if (organization) {
            vendor = organization.name;
            if (organization.url) {
                vendor = (React.createElement("a", { href: organization.url, rel: "noopener noreferrer", target: "_blank" }, vendor));
            }
        }
        return (React.createElement("div", { className: "update-center-meta-data" },
            React.createElement("div", { className: "update-center-meta-data-header" },
                vendor && React.createElement("span", { className: "update-center-meta-data-vendor" },
                    "By ",
                    vendor),
                license && React.createElement("span", { className: "update-center-meta-data-license" }, license),
                issueTrackerURL && (React.createElement("span", { className: "update-center-meta-data-issue-tracker" },
                    React.createElement("a", { href: issueTrackerURL, rel: "noopener noreferrer", target: "_blank" }, "Issue Tracker"))),
                isSonarSourceCommercial && (React.createElement("span", { className: "update-center-meta-data-supported" }, "Supported by SonarSource"))),
            versions && versions.length > 0 && React.createElement(MetaDataVersions_1.default, { versions: versions })));
    };
    return MetaData;
}(React.Component));
exports.default = MetaData;
//# sourceMappingURL=MetaData.js.map