"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
var classnames_1 = require("classnames");
var React = require("react");
function MetaDataVersion(props) {
    var _a = props.versionInformation, archived = _a.archived, changeLogUrl = _a.changeLogUrl, compatibility = _a.compatibility, date = _a.date, description = _a.description, downloadURL = _a.downloadURL, version = _a.version;
    var fallbackLabel = 'Download';
    var advancedDownloadUrls = isAdvancedDownloadUrlArray(downloadURL)
        ? downloadURL.map(function (url) { return (__assign(__assign({}, url), { label: url.label || fallbackLabel })); })
        : [{ label: fallbackLabel, url: downloadURL }];
    return (React.createElement("div", { className: classnames_1.default('update-center-meta-data-version', {
            'update-center-meta-data-version-archived': archived,
        }) },
        React.createElement("div", { className: "update-center-meta-data-version-version" }, version),
        React.createElement("div", { className: "update-center-meta-data-version-release-info" },
            date && React.createElement("time", { className: "update-center-meta-data-version-release-date" }, date),
            compatibility && (React.createElement("span", { className: "update-center-meta-data-version-compatibility" }, compatibility))),
        description && (React.createElement("div", { className: "update-center-meta-data-version-release-description" }, description)),
        (advancedDownloadUrls.length > 0 || changeLogUrl) && (React.createElement("div", { className: "update-center-meta-data-version-release-links" },
            advancedDownloadUrls.length > 0 &&
                advancedDownloadUrls.map(function (advancedDownloadUrl, i) {
                    return advancedDownloadUrl.url && (React.createElement("span", { className: "update-center-meta-data-version-download", key: i },
                        React.createElement("a", { href: advancedDownloadUrl.url, rel: "noopener noreferrer", target: "_blank" }, advancedDownloadUrl.label)));
                }),
            changeLogUrl && (React.createElement("span", { className: "update-center-meta-data-version-release-notes" },
                React.createElement("a", { href: changeLogUrl, rel: "noopener noreferrer", target: "_blank" }, "Release notes")))))));
}
exports.default = MetaDataVersion;
function isAdvancedDownloadUrlArray(downloadUrl) {
    return !!downloadUrl && typeof downloadUrl !== 'string';
}
//# sourceMappingURL=MetaDataVersion.js.map