"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
Object.defineProperty(exports, "__esModule", { value: true });
var React = require("react");
var MetaDataVersion_1 = require("./MetaDataVersion");
var MetaDataVersions = (function (_super) {
    __extends(MetaDataVersions, _super);
    function MetaDataVersions() {
        var _this = _super !== null && _super.apply(this, arguments) || this;
        _this.state = {
            collapsed: true,
        };
        _this.handleClick = function (event) {
            event.preventDefault();
            event.currentTarget.blur();
            _this.setState(function (_a) {
                var collapsed = _a.collapsed;
                return ({ collapsed: !collapsed });
            });
        };
        return _this;
    }
    MetaDataVersions.prototype.componentDidUpdate = function (prevProps) {
        if (prevProps.versions !== this.props.versions) {
            this.setState({ collapsed: true });
        }
    };
    MetaDataVersions.prototype.render = function () {
        var versions = this.props.versions;
        var collapsed = this.state.collapsed;
        var archivedVersions = versions.filter(function (version) { return version.archived; });
        var currentVersions = versions.filter(function (version) { return !version.archived; });
        return (React.createElement("div", { className: "update-center-meta-data-versions" },
            archivedVersions.length > 0 && (React.createElement("button", { className: "update-center-meta-data-versions-show-more", onClick: this.handleClick, type: "button" }, collapsed ? 'Show more versions' : 'Show fewer versions')),
            currentVersions.map(function (versionInformation) { return (React.createElement(MetaDataVersion_1.default, { key: versionInformation.version, versionInformation: versionInformation })); }),
            !collapsed &&
                archivedVersions.map(function (archivedVersionInformation) { return (React.createElement(MetaDataVersion_1.default, { key: archivedVersionInformation.version, versionInformation: archivedVersionInformation })); })));
    };
    return MetaDataVersions;
}(React.Component));
exports.default = MetaDataVersions;
//# sourceMappingURL=MetaDataVersions.js.map