"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function stringToColor(str) {
    var hash = 0;
    for (var i = 0; i < str.length; i++) {
        hash = str.charCodeAt(i) + ((hash << 5) - hash);
    }
    var color = '#';
    for (var i = 0; i < 3; i++) {
        var value = (hash >> (i * 8)) & 0xff;
        color += ('00' + value.toString(16)).substr(-2);
    }
    return color;
}
exports.stringToColor = stringToColor;
function isDarkColor(color) {
    color = color.substr(1);
    if (color.length === 3) {
        color = color[0] + color[0] + color[1] + color[1] + color[2] + color[2];
    }
    var rgb = parseInt(color.substr(1), 16);
    var r = (rgb >> 16) & 0xff;
    var g = (rgb >> 8) & 0xff;
    var b = (rgb >> 0) & 0xff;
    var luma = 0.2126 * r + 0.7152 * g + 0.0722 * b;
    return luma < 140;
}
exports.isDarkColor = isDarkColor;
function getTextColor(background, dark, light) {
    if (dark === void 0) { dark = '#222'; }
    if (light === void 0) { light = '#fff'; }
    return isDarkColor(background) ? light : dark;
}
exports.getTextColor = getTextColor;
//# sourceMappingURL=colors.js.map