"use strict";
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
function collapsePath(path, limit) {
    if (limit === void 0) { limit = 30; }
    if (typeof path !== 'string') {
        return '';
    }
    var tokens = path.split('/');
    if (tokens.length <= 2) {
        return path;
    }
    var head = tokens[0];
    var tail = tokens[tokens.length - 1];
    var middle = tokens.slice(1, -1);
    var cut = false;
    while (middle.join().length > limit && middle.length > 0) {
        middle.shift();
        cut = true;
    }
    var body = __spreadArrays([head], (cut ? ['...'] : []), middle, [tail]);
    return body.join('/');
}
exports.collapsePath = collapsePath;
function collapsedDirFromPath(path) {
    var limit = 30;
    if (typeof path === 'string') {
        var tokens = path.split('/').slice(0, -1);
        if (tokens.length > 2) {
            var head = tokens[0];
            var tail = tokens[tokens.length - 1];
            var middle = tokens.slice(1, -1);
            var cut = false;
            while (middle.join().length > limit && middle.length > 0) {
                middle.shift();
                cut = true;
            }
            var body = __spreadArrays([head], (cut ? ['...'] : []), middle, [tail]);
            return body.join('/') + '/';
        }
        else {
            return tokens.join('/') + '/';
        }
    }
    else {
        return null;
    }
}
exports.collapsedDirFromPath = collapsedDirFromPath;
function fileFromPath(path) {
    if (typeof path === 'string') {
        var tokens = path.split('/');
        return tokens[tokens.length - 1];
    }
    else {
        return null;
    }
}
exports.fileFromPath = fileFromPath;
function splitPath(path) {
    var tokens = path.split('/');
    return {
        head: tokens.slice(0, -1).join('/'),
        tail: tokens[tokens.length - 1],
    };
}
exports.splitPath = splitPath;
function cutLongWords(str, limit) {
    if (limit === void 0) { limit = 30; }
    return str
        .split(' ')
        .map(function (word) { return (word.length > limit ? word.substr(0, limit) + '...' : word); })
        .join(' ');
}
exports.cutLongWords = cutLongWords;
function limitComponentName(str, limit) {
    if (limit === void 0) { limit = 30; }
    if (typeof str === 'string') {
        return str.length > limit ? str.substr(0, limit) + '...' : str;
    }
    else {
        return '';
    }
}
exports.limitComponentName = limitComponentName;
//# sourceMappingURL=path.js.map