import { toNotSoISOString } from './dates';
export declare function queriesEqual(a: T.RawQuery, b: T.RawQuery): boolean;
export declare function cleanQuery(query: T.RawQuery): T.RawQuery;
export declare function parseAsBoolean(value: string | undefined, defaultValue?: boolean): boolean;
export declare function parseAsOptionalBoolean(value: string | undefined): boolean | undefined;
export declare function parseAsDate(value?: string): Date | undefined;
export declare function parseAsString(value: string | undefined): string;
export declare function parseAsOptionalString(value: string | undefined): string | undefined;
export declare function parseAsArray<T>(value: string | undefined, itemParser: (x: string) => T): T[];
export declare function parseAsOptionalArray<T>(value: string | undefined, itemParser: (x: string) => T): T[] | undefined;
export declare function serializeDate(value?: Date, serializer?: typeof toNotSoISOString): string | undefined;
export declare function serializeDateShort(value: Date | undefined): string | undefined;
export declare function serializeString(value: string | undefined): string | undefined;
export declare function serializeStringArray(value: string[] | undefined[]): string | undefined;
export declare function serializeOptionalBoolean(value: boolean | undefined): string | undefined;
