"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
function checkNumberRating(coverageRating) {
    if (!(typeof coverageRating === 'number' && coverageRating > 0 && coverageRating < 6)) {
        throw new Error("Unknown number rating: \"" + coverageRating + "\"");
    }
}
function getCoverageRatingLabel(rating) {
    checkNumberRating(rating);
    var mapping = ['≥ 80%', '70% - 80%', '50% - 70%', '30% - 50%', '< 30%'];
    return mapping[rating - 1];
}
exports.getCoverageRatingLabel = getCoverageRatingLabel;
function getCoverageRatingAverageValue(rating) {
    checkNumberRating(rating);
    var mapping = [90, 75, 60, 40, 15];
    return mapping[rating - 1];
}
exports.getCoverageRatingAverageValue = getCoverageRatingAverageValue;
function getDuplicationsRatingLabel(rating) {
    checkNumberRating(rating);
    var mapping = ['< 3%', '3% - 5%', '5% - 10%', '10% - 20%', '> 20%'];
    return mapping[rating - 1];
}
exports.getDuplicationsRatingLabel = getDuplicationsRatingLabel;
function getDuplicationsRatingAverageValue(rating) {
    checkNumberRating(rating);
    var mapping = [1.5, 4, 7.5, 15, 30];
    return mapping[rating - 1];
}
exports.getDuplicationsRatingAverageValue = getDuplicationsRatingAverageValue;
function getSizeRatingLabel(rating) {
    checkNumberRating(rating);
    var mapping = ['< 1k', '1k - 10k', '10k - 100k', '100k - 500k', '> 500k'];
    return mapping[rating - 1];
}
exports.getSizeRatingLabel = getSizeRatingLabel;
function getSizeRatingAverageValue(rating) {
    checkNumberRating(rating);
    var mapping = [500, 5000, 50000, 250000, 750000];
    return mapping[rating - 1];
}
exports.getSizeRatingAverageValue = getSizeRatingAverageValue;
//# sourceMappingURL=ratings.js.map