export declare function getCSRFTokenName(): string;
export declare function getCSRFTokenValue(): string;
export declare function getCSRFToken(): T.Dict<string>;
export declare type RequestData = T.Dict<any>;
export declare function omitNil(obj: RequestData): RequestData;
declare class Request {
    private readonly url;
    private readonly options;
    private data?;
    private isJSON;
    constructor(url: string, options?: {
        method?: string;
    });
    getSubmitData(customHeaders?: any): {
        url: string;
        options: RequestInit;
    };
    submit(): Promise<Response>;
    setMethod(method: string): Request;
    setData(data?: RequestData, isJSON?: boolean): Request;
}
export declare function request(url: string): Request;
export declare function corsRequest(url: string, mode?: RequestMode): Request;
export declare function checkStatus(response: Response, bypassRedirect?: boolean): Promise<Response>;
export declare function parseJSON(response: Response): Promise<any>;
export declare function parseText(response: Response): Promise<string>;
export declare function parseError(response: Response): Promise<string>;
export declare function get(url: string, data?: RequestData, bypassRedirect?: boolean): Promise<Response>;
export declare function getJSON(url: string, data?: RequestData, bypassRedirect?: boolean): Promise<any>;
export declare function getText(url: string, data?: RequestData, bypassRedirect?: boolean): Promise<string>;
export declare function getCorsJSON(url: string, data?: RequestData): Promise<any>;
export declare function postJSON(url: string, data?: RequestData, bypassRedirect?: boolean): Promise<any>;
export declare function postJSONBody(url: string, data?: RequestData, bypassRedirect?: boolean): Promise<any>;
export declare function post(url: string, data?: RequestData, bypassRedirect?: boolean): Promise<void>;
export declare function requestTryAndRepeatUntil<T>(repeatAPICall: () => Promise<T>, tries: {
    max: number;
    slowThreshold: number;
}, stopRepeat: (response: T) => boolean, repeatErrors?: number[]): Promise<T>;
export declare function isSuccessStatus(status: number): boolean;
export declare enum HttpStatus {
    Ok = 200,
    Created = 201,
    MultipleChoices = 300,
    MovedPermanently = 301,
    Found = 302,
    BadRequest = 400,
    Unauthorized = 401,
    Forbidden = 403,
    NotFound = 404,
    InternalServerError = 500,
    NotImplemented = 501,
    BadGateway = 502,
    ServiceUnavailable = 503,
    GatewayTimeout = 504
}
export {};
