"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
Object.defineProperty(exports, "__esModule", { value: true });
function mockEvent(overrides) {
    if (overrides === void 0) { overrides = {}; }
    return __assign({ target: { blur: function () { } }, currentTarget: { blur: function () { } }, preventDefault: function () { },
        stopPropagation: function () { } }, overrides);
}
exports.mockEvent = mockEvent;
function click(element, event) {
    if (event === void 0) { event = {}; }
    if (typeof element.type() === 'function') {
        element.prop('onClick')();
        element.root().update();
    }
    else {
        element.simulate('click', mockEvent(event));
    }
}
exports.click = click;
function clickOutside(event) {
    if (event === void 0) { event = {}; }
    var dispatchedEvent = new MouseEvent('click', event);
    window.dispatchEvent(dispatchedEvent);
}
exports.clickOutside = clickOutside;
function submit(element) {
    element.simulate('submit', {
        preventDefault: function () { },
    });
}
exports.submit = submit;
function change(element, value, event) {
    if (event === void 0) { event = {}; }
    if (typeof element.type() === 'function') {
        element.prop('onChange')(value);
        element.root().update();
    }
    else {
        element.simulate('change', __assign({ target: { value: value }, currentTarget: { value: value } }, event));
    }
}
exports.change = change;
exports.KEYCODE_MAP = {
    13: 'enter',
    37: 'left',
    38: 'up',
    39: 'right',
    40: 'down',
};
function keydown(key) {
    var keyCode;
    if (typeof key === 'number') {
        keyCode = key;
    }
    else {
        console.warn('Using strings in keydown() is deprecated. Consider using the KeyCodes enum.');
        var mapped = Object.entries(exports.KEYCODE_MAP).find(function (_a) {
            var _ = _a[0], value = _a[1];
            return value === key;
        });
        if (!mapped) {
            throw new Error("Cannot map key \"" + key + "\" to a keyCode!");
        }
        keyCode = mapped[0];
    }
    var event = new KeyboardEvent('keydown', { keyCode: keyCode, which: keyCode });
    document.dispatchEvent(event);
}
exports.keydown = keydown;
function elementKeydown(element, keyCode) {
    var event = {
        currentTarget: { element: element },
        keyCode: keyCode,
        preventDefault: function () { },
    };
    if (typeof element.type() === 'string') {
        element.simulate('keydown', event);
    }
    else {
        element.prop('onKeyDown')(event);
    }
}
exports.elementKeydown = elementKeydown;
function resizeWindowTo(width, height) {
    if (width) {
        Object.defineProperty(document.documentElement, 'clientWidth', {
            configurable: true,
            value: width,
        });
    }
    if (height) {
        Object.defineProperty(document.documentElement, 'clientHeight', {
            configurable: true,
            value: height,
        });
    }
    var resizeEvent = new Event('resize');
    window.dispatchEvent(resizeEvent);
}
exports.resizeWindowTo = resizeWindowTo;
function scrollTo(_a) {
    var _b = _a.left, left = _b === void 0 ? 0 : _b, _c = _a.top, top = _c === void 0 ? 0 : _c;
    Object.defineProperty(window, 'pageYOffset', { value: top });
    Object.defineProperty(window, 'pageXOffset', { value: left });
    var resizeEvent = new Event('scroll');
    window.dispatchEvent(resizeEvent);
}
exports.scrollTo = scrollTo;
function setNodeRect(_a) {
    var _b = _a.width, width = _b === void 0 ? 50 : _b, _c = _a.height, height = _c === void 0 ? 50 : _c, _d = _a.left, left = _d === void 0 ? 0 : _d, _e = _a.top, top = _e === void 0 ? 0 : _e;
    var findDOMNode = require('react-dom').findDOMNode;
    var element = document.createElement('div');
    Object.defineProperty(element, 'getBoundingClientRect', {
        value: function () { return ({ width: width, height: height, left: left, top: top }); },
    });
    findDOMNode.mockReturnValue(element);
}
exports.setNodeRect = setNodeRect;
function doAsync(fn) {
    return new Promise(function (resolve) {
        setImmediate(function () {
            if (fn) {
                fn();
            }
            resolve();
        });
    });
}
exports.doAsync = doAsync;
function waitAndUpdate(wrapper) {
    return __awaiter(this, void 0, void 0, function () {
        return __generator(this, function (_a) {
            switch (_a.label) {
                case 0: return [4, new Promise(setImmediate)];
                case 1:
                    _a.sent();
                    wrapper.update();
                    return [2];
            }
        });
    });
}
exports.waitAndUpdate = waitAndUpdate;
//# sourceMappingURL=testUtils.js.map