"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var lodash_1 = require("lodash");
var querystring_1 = require("querystring");
var init_1 = require("./init");
function getBaseUrl() {
    return init_1.getUrlContext();
}
exports.getBaseUrl = getBaseUrl;
function getHostUrl() {
    if (init_1.IS_SSR) {
        throw new Error('No host url available on server side.');
    }
    return window.location.origin + getBaseUrl();
}
exports.getHostUrl = getHostUrl;
function getPathUrlAsString(path, internal) {
    if (internal === void 0) { internal = true; }
    return "" + (internal ? getBaseUrl() : getHostUrl()) + path.pathname + "?" + querystring_1.stringify(lodash_1.omitBy(path.query, lodash_1.isNil));
}
exports.getPathUrlAsString = getPathUrlAsString;
function getReturnUrl(location) {
    var returnTo = location.query && location.query['return_to'];
    if (isRelativeUrl(returnTo)) {
        return returnTo + (location.hash ? location.hash : '');
    }
    return getBaseUrl() + '/';
}
exports.getReturnUrl = getReturnUrl;
function isRelativeUrl(url) {
    var regex = new RegExp(/^\/[^/\\]/);
    return Boolean(url && regex.test(url));
}
exports.isRelativeUrl = isRelativeUrl;
//# sourceMappingURL=urls.js.map