/*
 * Sonar UI Common
 * Copyright (C) 2019-2020 SonarSource SA
 * mailto:info AT sonarsource DOT com
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software Foundation,
 * Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 */
declare namespace T {
  export type Dict<T> = { [key: string]: T };
  export type Omit<T, K extends keyof T> = Pick<T, Exclude<keyof T, K>>;

  // Type ordered alphabetically to prevent merge conflicts

  export type IssueType = 'BUG' | 'VULNERABILITY' | 'CODE_SMELL' | 'SECURITY_HOTSPOT';

  export type RawQuery = T.Dict<any>;

  export namespace Chart {
    export interface Point {
      x: Date;
      y: number | string | undefined;
    }

    export interface Serie {
      data: Point[];
      name: string;
      translatedName: string;
      type: string;
    }
  }
}
